/* CustomSearchDialog.c generated by valac 0.44.3, the Vala compiler
 * generated from CustomSearchDialog.vala, do not modify */

/*
* Copyright © 2019 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <granite.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_CUSTOM_SEARCH_DIALOG (custom_search_dialog_get_type ())
#define CUSTOM_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CUSTOM_SEARCH_DIALOG, CustomSearchDialog))
#define CUSTOM_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CUSTOM_SEARCH_DIALOG, CustomSearchDialogClass))
#define IS_CUSTOM_SEARCH_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CUSTOM_SEARCH_DIALOG))
#define IS_CUSTOM_SEARCH_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CUSTOM_SEARCH_DIALOG))
#define CUSTOM_SEARCH_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CUSTOM_SEARCH_DIALOG, CustomSearchDialogClass))

typedef struct _CustomSearchDialog CustomSearchDialog;
typedef struct _CustomSearchDialogClass CustomSearchDialogClass;
typedef struct _CustomSearchDialogPrivate CustomSearchDialogPrivate;
enum  {
	CUSTOM_SEARCH_DIALOG_0_PROPERTY,
	CUSTOM_SEARCH_DIALOG_NUM_PROPERTIES
};
static GParamSpec* custom_search_dialog_properties[CUSTOM_SEARCH_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CustomSearchDialog {
	GraniteMessageDialog parent_instance;
	CustomSearchDialogPrivate * priv;
};

struct _CustomSearchDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _Block5Data {
	int _ref_count_;
	CustomSearchDialog* self;
	GtkEntry* search_entry;
};

static gpointer custom_search_dialog_parent_class = NULL;
extern GSettings* ephemeral_settings;

GType custom_search_dialog_get_type (void) G_GNUC_CONST;
CustomSearchDialog* custom_search_dialog_new (void);
CustomSearchDialog* custom_search_dialog_construct (GType object_type);
static GObject * custom_search_dialog_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _custom_search_dialog___lambda28_ (CustomSearchDialog* self);
static void __custom_search_dialog___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static gboolean _custom_search_dialog___lambda29_ (CustomSearchDialog* self,
                                            GBinding* binding,
                                            GValue* srcval,
                                            GValue* targetval);
static gboolean __custom_search_dialog___lambda29__gbinding_transform_func (GBinding* binding,
                                                                     GValue* from_value,
                                                                     GValue* to_value,
                                                                     gpointer self);
static void _custom_search_dialog___lambda30_ (Block5Data* _data5_);
static void __custom_search_dialog___lambda30__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);

CustomSearchDialog*
custom_search_dialog_construct (GType object_type)
{
	CustomSearchDialog * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 24 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("system-search");
#line 24 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp1_ = _tmp0_;
#line 24 "../src/Dialogs/CustomSearchDialog.vala"
	self = (CustomSearchDialog*) g_object_new (object_type, "image-icon", _tmp1_, "primary-text", _ ("Set a Custom Search Engine"), "secondary-text", _ ("Searches from the URL entry will be sent to this custom URL. <b>%s</b>" \
" will be replaced with the search query."), "title", _ ("Custom Search Engine"), NULL);
#line 24 "../src/Dialogs/CustomSearchDialog.vala"
	_g_object_unref0 (_tmp1_);
#line 23 "../src/Dialogs/CustomSearchDialog.vala"
	return self;
#line 111 "CustomSearchDialog.c"
}

CustomSearchDialog*
custom_search_dialog_new (void)
{
#line 23 "../src/Dialogs/CustomSearchDialog.vala"
	return custom_search_dialog_construct (TYPE_CUSTOM_SEARCH_DIALOG);
#line 119 "CustomSearchDialog.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	return _data5_;
#line 129 "CustomSearchDialog.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 139 "CustomSearchDialog.c"
		CustomSearchDialog* self;
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
		self = _data5_->self;
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
		_g_object_unref0 (_data5_->search_entry);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
		_g_object_unref0 (self);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
		g_slice_free (Block5Data, _data5_);
#line 149 "CustomSearchDialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../src/Dialogs/CustomSearchDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 158 "CustomSearchDialog.c"
}

static void
_custom_search_dialog___lambda28_ (CustomSearchDialog* self)
{
#line 36 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 166 "CustomSearchDialog.c"
}

static void
__custom_search_dialog___lambda28__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 36 "../src/Dialogs/CustomSearchDialog.vala"
	_custom_search_dialog___lambda28_ ((CustomSearchDialog*) self);
#line 175 "CustomSearchDialog.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 194 "CustomSearchDialog.c"
}

static gboolean
_custom_search_dialog___lambda29_ (CustomSearchDialog* self,
                                   GBinding* binding,
                                   GValue* srcval,
                                   GValue* targetval)
{
	gboolean result = FALSE;
	gchar* text = NULL;
	GValue _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 45 "../src/Dialogs/CustomSearchDialog.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 45 "../src/Dialogs/CustomSearchDialog.vala"
	g_return_val_if_fail (srcval != NULL, FALSE);
#line 45 "../src/Dialogs/CustomSearchDialog.vala"
	g_return_val_if_fail (targetval != NULL, FALSE);
#line 46 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp0_ = *srcval;
#line 46 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp1_ = g_strdup (g_value_get_string (&_tmp0_));
#line 46 "../src/Dialogs/CustomSearchDialog.vala"
	text = _tmp1_;
#line 48 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp4_ = text;
#line 48 "../src/Dialogs/CustomSearchDialog.vala"
	if (string_contains (_tmp4_, "%s")) {
#line 226 "CustomSearchDialog.c"
		const gchar* _tmp5_;
#line 49 "../src/Dialogs/CustomSearchDialog.vala"
		_tmp5_ = text;
#line 49 "../src/Dialogs/CustomSearchDialog.vala"
		_tmp3_ = string_contains (_tmp5_, ".");
#line 232 "CustomSearchDialog.c"
	} else {
#line 48 "../src/Dialogs/CustomSearchDialog.vala"
		_tmp3_ = FALSE;
#line 236 "CustomSearchDialog.c"
	}
#line 48 "../src/Dialogs/CustomSearchDialog.vala"
	if (_tmp3_) {
#line 240 "CustomSearchDialog.c"
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
#line 50 "../src/Dialogs/CustomSearchDialog.vala"
		_tmp7_ = text;
#line 50 "../src/Dialogs/CustomSearchDialog.vala"
		if (g_str_has_prefix (_tmp7_, "http://")) {
#line 50 "../src/Dialogs/CustomSearchDialog.vala"
			_tmp6_ = TRUE;
#line 249 "CustomSearchDialog.c"
		} else {
			const gchar* _tmp8_;
#line 51 "../src/Dialogs/CustomSearchDialog.vala"
			_tmp8_ = text;
#line 51 "../src/Dialogs/CustomSearchDialog.vala"
			_tmp6_ = g_str_has_prefix (_tmp8_, "https://");
#line 256 "CustomSearchDialog.c"
		}
#line 50 "../src/Dialogs/CustomSearchDialog.vala"
		_tmp2_ = _tmp6_;
#line 260 "CustomSearchDialog.c"
	} else {
#line 48 "../src/Dialogs/CustomSearchDialog.vala"
		_tmp2_ = FALSE;
#line 264 "CustomSearchDialog.c"
	}
#line 47 "../src/Dialogs/CustomSearchDialog.vala"
	g_value_set_boolean (targetval, _tmp2_);
#line 54 "../src/Dialogs/CustomSearchDialog.vala"
	result = TRUE;
#line 54 "../src/Dialogs/CustomSearchDialog.vala"
	_g_free0 (text);
#line 54 "../src/Dialogs/CustomSearchDialog.vala"
	return result;
#line 274 "CustomSearchDialog.c"
}

static gboolean
__custom_search_dialog___lambda29__gbinding_transform_func (GBinding* binding,
                                                            GValue* from_value,
                                                            GValue* to_value,
                                                            gpointer self)
{
	gboolean result;
	result = _custom_search_dialog___lambda29_ ((CustomSearchDialog*) self, binding, from_value, to_value);
#line 44 "../src/Dialogs/CustomSearchDialog.vala"
	return result;
#line 287 "CustomSearchDialog.c"
}

static void
_custom_search_dialog___lambda30_ (Block5Data* _data5_)
{
	CustomSearchDialog* self;
	GSettings* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 63 "../src/Dialogs/CustomSearchDialog.vala"
	self = _data5_->self;
#line 64 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp0_ = ephemeral_settings;
#line 64 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp1_ = _data5_->search_entry;
#line 64 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 64 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp3_ = _tmp2_;
#line 64 "../src/Dialogs/CustomSearchDialog.vala"
	g_settings_set_string (_tmp0_, "search-engine", _tmp3_);
#line 310 "CustomSearchDialog.c"
}

static void
__custom_search_dialog___lambda30__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
#line 63 "../src/Dialogs/CustomSearchDialog.vala"
	_custom_search_dialog___lambda30_ (self);
#line 319 "CustomSearchDialog.c"
}

static GObject *
custom_search_dialog_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CustomSearchDialog * self;
	Block5Data* _data5_;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkButton* cancel = NULL;
	GtkWidget* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* accept = NULL;
	GtkWidget* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GtkEntry* _tmp11_;
	GSettings* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkEntry* _tmp15_;
	GtkButton* _tmp16_;
	GtkBin* _tmp17_;
	GtkBin* _tmp18_;
	GtkEntry* _tmp19_;
	GtkBin* _tmp20_;
	GtkBin* _tmp21_;
	GtkButton* _tmp22_;
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	parent_class = G_OBJECT_CLASS (custom_search_dialog_parent_class);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CUSTOM_SEARCH_DIALOG, CustomSearchDialog);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	_data5_->_ref_count_ = 1;
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	_data5_->self = g_object_ref (self);
#line 33 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp0_ = granite_message_dialog_get_secondary_label ((GraniteMessageDialog*) self);
#line 33 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_label_set_use_markup (_tmp1_, TRUE);
#line 35 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp2_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Never Mind"), (gint) GTK_RESPONSE_CANCEL);
#line 35 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_button_get_type ()) ? ((GtkButton*) _tmp2_) : NULL);
#line 35 "../src/Dialogs/CustomSearchDialog.vala"
	cancel = _tmp3_;
#line 36 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp4_ = cancel;
#line 36 "../src/Dialogs/CustomSearchDialog.vala"
	g_signal_connect_object (_tmp4_, "clicked", (GCallback) __custom_search_dialog___lambda28__gtk_button_clicked, self, 0);
#line 38 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp5_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Set Search Engine"), (gint) GTK_RESPONSE_OK);
#line 38 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_button_get_type ()) ? ((GtkButton*) _tmp5_) : NULL);
#line 38 "../src/Dialogs/CustomSearchDialog.vala"
	accept = _tmp6_;
#line 39 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp7_ = accept;
#line 39 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 39 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_style_context_add_class (_tmp8_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 41 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp9_ = (GtkEntry*) gtk_entry_new ();
#line 41 "../src/Dialogs/CustomSearchDialog.vala"
	g_object_ref_sink (_tmp9_);
#line 41 "../src/Dialogs/CustomSearchDialog.vala"
	_data5_->search_entry = _tmp9_;
#line 42 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp10_ = _data5_->search_entry;
#line 42 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_entry_set_activates_default (_tmp10_, TRUE);
#line 43 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp11_ = _data5_->search_entry;
#line 43 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp12_ = ephemeral_settings;
#line 43 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp13_ = g_settings_get_string (_tmp12_, "search-engine");
#line 43 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp14_ = _tmp13_;
#line 43 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_entry_set_text (_tmp11_, _tmp14_);
#line 43 "../src/Dialogs/CustomSearchDialog.vala"
	_g_free0 (_tmp14_);
#line 44 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp15_ = _data5_->search_entry;
#line 44 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp16_ = accept;
#line 44 "../src/Dialogs/CustomSearchDialog.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp15_, "text", (GObject*) _tmp16_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((__custom_search_dialog___lambda29__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) __custom_search_dialog___lambda29__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 58 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp17_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
#line 58 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp18_ = _tmp17_;
#line 58 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp19_ = _data5_->search_entry;
#line 58 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 59 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp20_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
#line 59 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp21_ = _tmp20_;
#line 59 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp21_);
#line 61 "../src/Dialogs/CustomSearchDialog.vala"
	gtk_dialog_set_default_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 63 "../src/Dialogs/CustomSearchDialog.vala"
	_tmp22_ = accept;
#line 63 "../src/Dialogs/CustomSearchDialog.vala"
	g_signal_connect_data (_tmp22_, "clicked", (GCallback) __custom_search_dialog___lambda30__gtk_button_clicked, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	_g_object_unref0 (accept);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	_g_object_unref0 (cancel);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	block5_data_unref (_data5_);
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	_data5_ = NULL;
#line 32 "../src/Dialogs/CustomSearchDialog.vala"
	return obj;
#line 454 "CustomSearchDialog.c"
}

static void
custom_search_dialog_class_init (CustomSearchDialogClass * klass,
                                 gpointer klass_data)
{
#line 22 "../src/Dialogs/CustomSearchDialog.vala"
	custom_search_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Dialogs/CustomSearchDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = custom_search_dialog_constructor;
#line 465 "CustomSearchDialog.c"
}

static void
custom_search_dialog_instance_init (CustomSearchDialog * self,
                                    gpointer klass)
{
}

GType
custom_search_dialog_get_type (void)
{
	static volatile gsize custom_search_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&custom_search_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CustomSearchDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) custom_search_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CustomSearchDialog), 0, (GInstanceInitFunc) custom_search_dialog_instance_init, NULL };
		GType custom_search_dialog_type_id;
		custom_search_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "CustomSearchDialog", &g_define_type_info, 0);
		g_once_init_leave (&custom_search_dialog_type_id__volatile, custom_search_dialog_type_id);
	}
	return custom_search_dialog_type_id__volatile;
}

