/* ExternalDialog.c generated by valac 0.44.3, the Vala compiler
 * generated from ExternalDialog.vala, do not modify */

/*
* Copyright © 2019 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <granite.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define TYPE_EXTERNAL_DIALOG (external_dialog_get_type ())
#define EXTERNAL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTERNAL_DIALOG, ExternalDialog))
#define EXTERNAL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXTERNAL_DIALOG, ExternalDialogClass))
#define IS_EXTERNAL_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTERNAL_DIALOG))
#define IS_EXTERNAL_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXTERNAL_DIALOG))
#define EXTERNAL_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXTERNAL_DIALOG, ExternalDialogClass))

typedef struct _ExternalDialog ExternalDialog;
typedef struct _ExternalDialogClass ExternalDialogClass;
typedef struct _ExternalDialogPrivate ExternalDialogPrivate;
enum  {
	EXTERNAL_DIALOG_0_PROPERTY,
	EXTERNAL_DIALOG_PROTOCOL_PROPERTY,
	EXTERNAL_DIALOG_NUM_PROPERTIES
};
static GParamSpec* external_dialog_properties[EXTERNAL_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ExternalDialog {
	GraniteMessageDialog parent_instance;
	ExternalDialogPrivate * priv;
};

struct _ExternalDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _ExternalDialogPrivate {
	gchar* _protocol;
};

static gint ExternalDialog_private_offset;
static gpointer external_dialog_parent_class = NULL;

GType external_dialog_get_type (void) G_GNUC_CONST;
ExternalDialog* external_dialog_new (const gchar* _protocol);
ExternalDialog* external_dialog_construct (GType object_type,
                                           const gchar* _protocol);
const gchar* external_dialog_get_protocol (ExternalDialog* self);
void external_dialog_set_protocol (ExternalDialog* self,
                                   const gchar* value);
static GObject * external_dialog_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _external_dialog___lambda15_ (ExternalDialog* self);
static void __external_dialog___lambda15__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self);
static void external_dialog_finalize (GObject * obj);
static void _vala_external_dialog_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_external_dialog_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
external_dialog_get_instance_private (ExternalDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ExternalDialog_private_offset);
}

ExternalDialog*
external_dialog_construct (GType object_type,
                           const gchar* _protocol)
{
	ExternalDialog * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 26 "../src/Dialogs/ExternalDialog.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 26 "../src/Dialogs/ExternalDialog.vala"
	_tmp1_ = _tmp0_;
#line 26 "../src/Dialogs/ExternalDialog.vala"
	self = (ExternalDialog*) g_object_new (object_type, "image-icon", _tmp1_, "primary-text", _ ("Open Externally?"), "protocol", _protocol, "title", _ ("Open Externally?"), NULL);
#line 26 "../src/Dialogs/ExternalDialog.vala"
	_g_object_unref0 (_tmp1_);
#line 25 "../src/Dialogs/ExternalDialog.vala"
	return self;
#line 116 "ExternalDialog.c"
}

ExternalDialog*
external_dialog_new (const gchar* _protocol)
{
#line 25 "../src/Dialogs/ExternalDialog.vala"
	return external_dialog_construct (TYPE_EXTERNAL_DIALOG, _protocol);
#line 124 "ExternalDialog.c"
}

const gchar*
external_dialog_get_protocol (ExternalDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/Dialogs/ExternalDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Dialogs/ExternalDialog.vala"
	_tmp0_ = self->priv->_protocol;
#line 23 "../src/Dialogs/ExternalDialog.vala"
	result = _tmp0_;
#line 23 "../src/Dialogs/ExternalDialog.vala"
	return result;
#line 140 "ExternalDialog.c"
}

void
external_dialog_set_protocol (ExternalDialog* self,
                              const gchar* value)
{
#line 23 "../src/Dialogs/ExternalDialog.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Dialogs/ExternalDialog.vala"
	if (g_strcmp0 (value, external_dialog_get_protocol (self)) != 0) {
#line 151 "ExternalDialog.c"
		gchar* _tmp0_;
#line 23 "../src/Dialogs/ExternalDialog.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/Dialogs/ExternalDialog.vala"
		_g_free0 (self->priv->_protocol);
#line 23 "../src/Dialogs/ExternalDialog.vala"
		self->priv->_protocol = _tmp0_;
#line 23 "../src/Dialogs/ExternalDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, external_dialog_properties[EXTERNAL_DIALOG_PROTOCOL_PROPERTY]);
#line 161 "ExternalDialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 46 "../src/Dialogs/ExternalDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 170 "ExternalDialog.c"
}

static void
_external_dialog___lambda15_ (ExternalDialog* self)
{
#line 47 "../src/Dialogs/ExternalDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 178 "ExternalDialog.c"
}

static void
__external_dialog___lambda15__gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self)
{
#line 47 "../src/Dialogs/ExternalDialog.vala"
	_external_dialog___lambda15_ ((ExternalDialog*) self);
#line 187 "ExternalDialog.c"
}

static GObject *
external_dialog_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ExternalDialog * self;
	gchar* explanation = NULL;
	const gchar* _tmp0_;
	gchar* implication = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkButton* cancel = NULL;
	GtkWidget* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* accept = NULL;
	GtkWidget* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkStyleContext* _tmp15_;
#line 34 "../src/Dialogs/ExternalDialog.vala"
	parent_class = G_OBJECT_CLASS (external_dialog_parent_class);
#line 34 "../src/Dialogs/ExternalDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../src/Dialogs/ExternalDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXTERNAL_DIALOG, ExternalDialog);
#line 36 "../src/Dialogs/ExternalDialog.vala"
	_tmp0_ = self->priv->_protocol;
#line 36 "../src/Dialogs/ExternalDialog.vala"
	if (_tmp0_ != NULL) {
#line 225 "ExternalDialog.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 37 "../src/Dialogs/ExternalDialog.vala"
		_tmp1_ = self->priv->_protocol;
#line 37 "../src/Dialogs/ExternalDialog.vala"
		_tmp2_ = g_strdup_printf (_ ("This page is trying to open an app for “%s” links."), _tmp1_);
#line 37 "../src/Dialogs/ExternalDialog.vala"
		_g_free0 (explanation);
#line 37 "../src/Dialogs/ExternalDialog.vala"
		explanation = _tmp2_;
#line 236 "ExternalDialog.c"
	} else {
		gchar* _tmp3_;
#line 39 "../src/Dialogs/ExternalDialog.vala"
		_tmp3_ = g_strdup (_ ("This page is trying to open an app."));
#line 39 "../src/Dialogs/ExternalDialog.vala"
		_g_free0 (explanation);
#line 39 "../src/Dialogs/ExternalDialog.vala"
		explanation = _tmp3_;
#line 245 "ExternalDialog.c"
	}
#line 42 "../src/Dialogs/ExternalDialog.vala"
	_tmp4_ = g_strdup (_ ("Your data may not be kept private by the opened app."));
#line 42 "../src/Dialogs/ExternalDialog.vala"
	implication = _tmp4_;
#line 44 "../src/Dialogs/ExternalDialog.vala"
	_tmp5_ = explanation;
#line 44 "../src/Dialogs/ExternalDialog.vala"
	_tmp6_ = implication;
#line 44 "../src/Dialogs/ExternalDialog.vala"
	_tmp7_ = g_strdup_printf ("%s %s", _tmp5_, _tmp6_);
#line 44 "../src/Dialogs/ExternalDialog.vala"
	_tmp8_ = _tmp7_;
#line 44 "../src/Dialogs/ExternalDialog.vala"
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp8_);
#line 44 "../src/Dialogs/ExternalDialog.vala"
	_g_free0 (_tmp8_);
#line 46 "../src/Dialogs/ExternalDialog.vala"
	_tmp9_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Don’t Open"), (gint) GTK_RESPONSE_CANCEL);
#line 46 "../src/Dialogs/ExternalDialog.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gtk_button_get_type ()) ? ((GtkButton*) _tmp9_) : NULL);
#line 46 "../src/Dialogs/ExternalDialog.vala"
	cancel = _tmp10_;
#line 47 "../src/Dialogs/ExternalDialog.vala"
	_tmp11_ = cancel;
#line 47 "../src/Dialogs/ExternalDialog.vala"
	g_signal_connect_object (_tmp11_, "clicked", (GCallback) __external_dialog___lambda15__gtk_button_clicked, self, 0);
#line 49 "../src/Dialogs/ExternalDialog.vala"
	_tmp12_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Open Anyway"), (gint) GTK_RESPONSE_OK);
#line 49 "../src/Dialogs/ExternalDialog.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_button_get_type ()) ? ((GtkButton*) _tmp12_) : NULL);
#line 49 "../src/Dialogs/ExternalDialog.vala"
	accept = _tmp13_;
#line 50 "../src/Dialogs/ExternalDialog.vala"
	_tmp14_ = accept;
#line 50 "../src/Dialogs/ExternalDialog.vala"
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) _tmp14_);
#line 50 "../src/Dialogs/ExternalDialog.vala"
	gtk_style_context_add_class (_tmp15_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 34 "../src/Dialogs/ExternalDialog.vala"
	_g_object_unref0 (accept);
#line 34 "../src/Dialogs/ExternalDialog.vala"
	_g_object_unref0 (cancel);
#line 34 "../src/Dialogs/ExternalDialog.vala"
	_g_free0 (implication);
#line 34 "../src/Dialogs/ExternalDialog.vala"
	_g_free0 (explanation);
#line 34 "../src/Dialogs/ExternalDialog.vala"
	return obj;
#line 295 "ExternalDialog.c"
}

static void
external_dialog_class_init (ExternalDialogClass * klass,
                            gpointer klass_data)
{
#line 22 "../src/Dialogs/ExternalDialog.vala"
	external_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Dialogs/ExternalDialog.vala"
	g_type_class_adjust_private_offset (klass, &ExternalDialog_private_offset);
#line 22 "../src/Dialogs/ExternalDialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_external_dialog_get_property;
#line 22 "../src/Dialogs/ExternalDialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_external_dialog_set_property;
#line 22 "../src/Dialogs/ExternalDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = external_dialog_constructor;
#line 22 "../src/Dialogs/ExternalDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = external_dialog_finalize;
#line 22 "../src/Dialogs/ExternalDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EXTERNAL_DIALOG_PROTOCOL_PROPERTY, external_dialog_properties[EXTERNAL_DIALOG_PROTOCOL_PROPERTY] = g_param_spec_string ("protocol", "protocol", "protocol", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 316 "ExternalDialog.c"
}

static void
external_dialog_instance_init (ExternalDialog * self,
                               gpointer klass)
{
#line 22 "../src/Dialogs/ExternalDialog.vala"
	self->priv = external_dialog_get_instance_private (self);
#line 325 "ExternalDialog.c"
}

static void
external_dialog_finalize (GObject * obj)
{
	ExternalDialog * self;
#line 22 "../src/Dialogs/ExternalDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXTERNAL_DIALOG, ExternalDialog);
#line 23 "../src/Dialogs/ExternalDialog.vala"
	_g_free0 (self->priv->_protocol);
#line 22 "../src/Dialogs/ExternalDialog.vala"
	G_OBJECT_CLASS (external_dialog_parent_class)->finalize (obj);
#line 338 "ExternalDialog.c"
}

GType
external_dialog_get_type (void)
{
	static volatile gsize external_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&external_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ExternalDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) external_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExternalDialog), 0, (GInstanceInitFunc) external_dialog_instance_init, NULL };
		GType external_dialog_type_id;
		external_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "ExternalDialog", &g_define_type_info, 0);
		ExternalDialog_private_offset = g_type_add_instance_private (external_dialog_type_id, sizeof (ExternalDialogPrivate));
		g_once_init_leave (&external_dialog_type_id__volatile, external_dialog_type_id);
	}
	return external_dialog_type_id__volatile;
}

static void
_vala_external_dialog_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	ExternalDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EXTERNAL_DIALOG, ExternalDialog);
#line 22 "../src/Dialogs/ExternalDialog.vala"
	switch (property_id) {
#line 22 "../src/Dialogs/ExternalDialog.vala"
		case EXTERNAL_DIALOG_PROTOCOL_PROPERTY:
#line 22 "../src/Dialogs/ExternalDialog.vala"
		g_value_set_string (value, external_dialog_get_protocol (self));
#line 22 "../src/Dialogs/ExternalDialog.vala"
		break;
#line 371 "ExternalDialog.c"
		default:
#line 22 "../src/Dialogs/ExternalDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Dialogs/ExternalDialog.vala"
		break;
#line 377 "ExternalDialog.c"
	}
}

static void
_vala_external_dialog_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	ExternalDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EXTERNAL_DIALOG, ExternalDialog);
#line 22 "../src/Dialogs/ExternalDialog.vala"
	switch (property_id) {
#line 22 "../src/Dialogs/ExternalDialog.vala"
		case EXTERNAL_DIALOG_PROTOCOL_PROPERTY:
#line 22 "../src/Dialogs/ExternalDialog.vala"
		external_dialog_set_protocol (self, g_value_get_string (value));
#line 22 "../src/Dialogs/ExternalDialog.vala"
		break;
#line 397 "ExternalDialog.c"
		default:
#line 22 "../src/Dialogs/ExternalDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Dialogs/ExternalDialog.vala"
		break;
#line 403 "ExternalDialog.c"
	}
}

