/* NetworkInfoBar.c generated by valac 0.44.3, the Vala compiler
 * generated from NetworkInfoBar.vala, do not modify */

/*
* Copyright © 2019 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define TYPE_NETWORK_INFO_BAR (network_info_bar_get_type ())
#define NETWORK_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NETWORK_INFO_BAR, NetworkInfoBar))
#define NETWORK_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NETWORK_INFO_BAR, NetworkInfoBarClass))
#define IS_NETWORK_INFO_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NETWORK_INFO_BAR))
#define IS_NETWORK_INFO_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NETWORK_INFO_BAR))
#define NETWORK_INFO_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NETWORK_INFO_BAR, NetworkInfoBarClass))

typedef struct _NetworkInfoBar NetworkInfoBar;
typedef struct _NetworkInfoBarClass NetworkInfoBarClass;
typedef struct _NetworkInfoBarPrivate NetworkInfoBarPrivate;
enum  {
	NETWORK_INFO_BAR_0_PROPERTY,
	NETWORK_INFO_BAR_NUM_PROPERTIES
};
static GParamSpec* network_info_bar_properties[NETWORK_INFO_BAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NetworkInfoBar {
	GtkInfoBar parent_instance;
	NetworkInfoBarPrivate * priv;
};

struct _NetworkInfoBarClass {
	GtkInfoBarClass parent_class;
};

static gpointer network_info_bar_parent_class = NULL;
extern GSettings* ephemeral_settings;

GType network_info_bar_get_type (void) G_GNUC_CONST;
NetworkInfoBar* network_info_bar_new (void);
NetworkInfoBar* network_info_bar_construct (GType object_type);
static void network_info_bar_try_set_revealed (NetworkInfoBar* self,
                                        gboolean* reveal);
static GObject * network_info_bar_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void _network_info_bar___lambda20_ (NetworkInfoBar* self,
                                    gint response_id);
static void __network_info_bar___lambda20__gtk_info_bar_response (GtkInfoBar* _sender,
                                                           gint response_id,
                                                           gpointer self);
static void _network_info_bar___lambda21_ (NetworkInfoBar* self);
static void __network_info_bar___lambda21__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                                       gboolean network_available,
                                                                       gpointer self);

NetworkInfoBar*
network_info_bar_construct (GType object_type)
{
	NetworkInfoBar * self = NULL;
#line 24 "../src/Widgets/NetworkInfoBar.vala"
	self = (NetworkInfoBar*) g_object_new (object_type, "message-type", GTK_MESSAGE_WARNING, "show-close-button", TRUE, NULL);
#line 23 "../src/Widgets/NetworkInfoBar.vala"
	return self;
#line 91 "NetworkInfoBar.c"
}

NetworkInfoBar*
network_info_bar_new (void)
{
#line 23 "../src/Widgets/NetworkInfoBar.vala"
	return network_info_bar_construct (TYPE_NETWORK_INFO_BAR);
#line 99 "NetworkInfoBar.c"
}

static void
network_info_bar_try_set_revealed (NetworkInfoBar* self,
                                   gboolean* reveal)
{
	gboolean network_available = FALSE;
	GNetworkMonitor* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 74 "../src/Widgets/NetworkInfoBar.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/Widgets/NetworkInfoBar.vala"
	_tmp0_ = g_network_monitor_get_default ();
#line 75 "../src/Widgets/NetworkInfoBar.vala"
	network_available = g_network_monitor_get_network_available (_tmp0_);
#line 78 "../src/Widgets/NetworkInfoBar.vala"
	if (*reveal) {
#line 118 "NetworkInfoBar.c"
		GSettings* _tmp3_;
#line 79 "../src/Widgets/NetworkInfoBar.vala"
		_tmp3_ = ephemeral_settings;
#line 79 "../src/Widgets/NetworkInfoBar.vala"
		_tmp2_ = g_settings_get_boolean (_tmp3_, "warn-network");
#line 124 "NetworkInfoBar.c"
	} else {
#line 78 "../src/Widgets/NetworkInfoBar.vala"
		_tmp2_ = FALSE;
#line 128 "NetworkInfoBar.c"
	}
#line 78 "../src/Widgets/NetworkInfoBar.vala"
	if (_tmp2_) {
#line 80 "../src/Widgets/NetworkInfoBar.vala"
		_tmp1_ = !network_available;
#line 134 "NetworkInfoBar.c"
	} else {
#line 78 "../src/Widgets/NetworkInfoBar.vala"
		_tmp1_ = FALSE;
#line 138 "NetworkInfoBar.c"
	}
#line 77 "../src/Widgets/NetworkInfoBar.vala"
	gtk_info_bar_set_revealed ((GtkInfoBar*) self, _tmp1_);
#line 142 "NetworkInfoBar.c"
}

static void
_network_info_bar___lambda20_ (NetworkInfoBar* self,
                               gint response_id)
{
	GError* _inner_error0_ = NULL;
#line 50 "../src/Widgets/NetworkInfoBar.vala"
	switch (response_id) {
#line 50 "../src/Widgets/NetworkInfoBar.vala"
		case GTK_RESPONSE_ACCEPT:
#line 154 "NetworkInfoBar.c"
		{
			{
#line 53 "../src/Widgets/NetworkInfoBar.vala"
				g_app_info_launch_default_for_uri ("settings://network", NULL, &_inner_error0_);
#line 53 "../src/Widgets/NetworkInfoBar.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "NetworkInfoBar.c"
					goto __catch6_g_error;
				}
			}
			goto __finally6;
			__catch6_g_error:
			{
				GError* e = NULL;
				GError* _tmp0_;
				const gchar* _tmp1_;
#line 52 "../src/Widgets/NetworkInfoBar.vala"
				e = _inner_error0_;
#line 52 "../src/Widgets/NetworkInfoBar.vala"
				_inner_error0_ = NULL;
#line 55 "../src/Widgets/NetworkInfoBar.vala"
				_tmp0_ = e;
#line 55 "../src/Widgets/NetworkInfoBar.vala"
				_tmp1_ = _tmp0_->message;
#line 55 "../src/Widgets/NetworkInfoBar.vala"
				g_critical ("NetworkInfoBar.vala:55: %s", _tmp1_);
#line 52 "../src/Widgets/NetworkInfoBar.vala"
				_g_error_free0 (e);
#line 183 "NetworkInfoBar.c"
			}
			__finally6:
#line 52 "../src/Widgets/NetworkInfoBar.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 52 "../src/Widgets/NetworkInfoBar.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 52 "../src/Widgets/NetworkInfoBar.vala"
				g_clear_error (&_inner_error0_);
#line 52 "../src/Widgets/NetworkInfoBar.vala"
				return;
#line 194 "NetworkInfoBar.c"
			}
#line 57 "../src/Widgets/NetworkInfoBar.vala"
			break;
#line 198 "NetworkInfoBar.c"
		}
#line 50 "../src/Widgets/NetworkInfoBar.vala"
		case GTK_RESPONSE_REJECT:
#line 202 "NetworkInfoBar.c"
		{
			GSettings* _tmp2_;
#line 59 "../src/Widgets/NetworkInfoBar.vala"
			_tmp2_ = ephemeral_settings;
#line 59 "../src/Widgets/NetworkInfoBar.vala"
			g_settings_set_boolean (_tmp2_, "warn-network", FALSE);
#line 209 "NetworkInfoBar.c"
		}
#line 50 "../src/Widgets/NetworkInfoBar.vala"
		case GTK_RESPONSE_CLOSE:
#line 213 "NetworkInfoBar.c"
		{
#line 61 "../src/Widgets/NetworkInfoBar.vala"
			gtk_info_bar_set_revealed ((GtkInfoBar*) self, FALSE);
#line 62 "../src/Widgets/NetworkInfoBar.vala"
			break;
#line 219 "NetworkInfoBar.c"
		}
		default:
		{
#line 64 "../src/Widgets/NetworkInfoBar.vala"
			g_assert_not_reached ();
#line 225 "NetworkInfoBar.c"
		}
	}
}

static void
__network_info_bar___lambda20__gtk_info_bar_response (GtkInfoBar* _sender,
                                                      gint response_id,
                                                      gpointer self)
{
#line 49 "../src/Widgets/NetworkInfoBar.vala"
	_network_info_bar___lambda20_ ((NetworkInfoBar*) self, response_id);
#line 237 "NetworkInfoBar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 68 "../src/Widgets/NetworkInfoBar.vala"
	return self ? g_object_ref (self) : NULL;
#line 245 "NetworkInfoBar.c"
}

static void
_network_info_bar___lambda21_ (NetworkInfoBar* self)
{
	gboolean _tmp0_;
#line 70 "../src/Widgets/NetworkInfoBar.vala"
	_tmp0_ = TRUE;
#line 70 "../src/Widgets/NetworkInfoBar.vala"
	network_info_bar_try_set_revealed (self, &_tmp0_);
#line 256 "NetworkInfoBar.c"
}

static void
__network_info_bar___lambda21__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                                  gboolean network_available,
                                                                  gpointer self)
{
#line 69 "../src/Widgets/NetworkInfoBar.vala"
	_network_info_bar___lambda21_ ((NetworkInfoBar*) self);
#line 266 "NetworkInfoBar.c"
}

static GObject *
network_info_bar_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkInfoBar * self;
	gchar* title = NULL;
	gchar* _tmp0_;
	gchar* details = NULL;
	gchar* _tmp1_;
	GtkLabel* default_label = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkButton* never_button = NULL;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkContainer* _tmp14_;
	GtkLabel* _tmp15_;
	GtkButton* _tmp16_;
	gboolean _tmp17_;
	GNetworkMonitor* network_monitor = NULL;
	GNetworkMonitor* _tmp18_;
	GNetworkMonitor* _tmp19_;
	GNetworkMonitor* _tmp20_;
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	parent_class = G_OBJECT_CLASS (network_info_bar_parent_class);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NETWORK_INFO_BAR, NetworkInfoBar);
#line 31 "../src/Widgets/NetworkInfoBar.vala"
	_tmp0_ = g_strdup (_ ("Network Not Available."));
#line 31 "../src/Widgets/NetworkInfoBar.vala"
	title = _tmp0_;
#line 32 "../src/Widgets/NetworkInfoBar.vala"
	_tmp1_ = g_strdup (_ ("Connect to the Internet to browse the Web."));
#line 32 "../src/Widgets/NetworkInfoBar.vala"
	details = _tmp1_;
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	_tmp2_ = title;
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	_tmp3_ = details;
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	_tmp4_ = g_strdup_printf ("<b>%s</b> %s", _tmp2_, _tmp3_);
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	_tmp5_ = _tmp4_;
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	g_object_ref_sink (_tmp6_);
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	_tmp7_ = _tmp6_;
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	_g_free0 (_tmp5_);
#line 34 "../src/Widgets/NetworkInfoBar.vala"
	default_label = _tmp7_;
#line 35 "../src/Widgets/NetworkInfoBar.vala"
	_tmp8_ = default_label;
#line 35 "../src/Widgets/NetworkInfoBar.vala"
	gtk_label_set_use_markup (_tmp8_, TRUE);
#line 36 "../src/Widgets/NetworkInfoBar.vala"
	_tmp9_ = default_label;
#line 36 "../src/Widgets/NetworkInfoBar.vala"
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
#line 38 "../src/Widgets/NetworkInfoBar.vala"
	_tmp10_ = (GtkButton*) gtk_button_new_with_label (_ ("Never Warn Again"));
#line 38 "../src/Widgets/NetworkInfoBar.vala"
	g_object_ref_sink (_tmp10_);
#line 38 "../src/Widgets/NetworkInfoBar.vala"
	never_button = _tmp10_;
#line 39 "../src/Widgets/NetworkInfoBar.vala"
	_tmp11_ = never_button;
#line 39 "../src/Widgets/NetworkInfoBar.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_END);
#line 40 "../src/Widgets/NetworkInfoBar.vala"
	_tmp12_ = never_button;
#line 40 "../src/Widgets/NetworkInfoBar.vala"
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
#line 40 "../src/Widgets/NetworkInfoBar.vala"
	gtk_style_context_add_class (_tmp13_, GTK_STYLE_CLASS_FLAT);
#line 42 "../src/Widgets/NetworkInfoBar.vala"
	_tmp14_ = gtk_info_bar_get_content_area ((GtkInfoBar*) self);
#line 42 "../src/Widgets/NetworkInfoBar.vala"
	_tmp15_ = default_label;
#line 42 "../src/Widgets/NetworkInfoBar.vala"
	gtk_container_add (_tmp14_, (GtkWidget*) _tmp15_);
#line 43 "../src/Widgets/NetworkInfoBar.vala"
	_tmp16_ = never_button;
#line 43 "../src/Widgets/NetworkInfoBar.vala"
	gtk_info_bar_add_action_widget ((GtkInfoBar*) self, (GtkWidget*) _tmp16_, (gint) GTK_RESPONSE_REJECT);
#line 45 "../src/Widgets/NetworkInfoBar.vala"
	gtk_info_bar_add_button ((GtkInfoBar*) self, _ ("Network Settings…"), (gint) GTK_RESPONSE_ACCEPT);
#line 47 "../src/Widgets/NetworkInfoBar.vala"
	_tmp17_ = TRUE;
#line 47 "../src/Widgets/NetworkInfoBar.vala"
	network_info_bar_try_set_revealed (self, &_tmp17_);
#line 49 "../src/Widgets/NetworkInfoBar.vala"
	g_signal_connect_object ((GtkInfoBar*) self, "response", (GCallback) __network_info_bar___lambda20__gtk_info_bar_response, self, 0);
#line 68 "../src/Widgets/NetworkInfoBar.vala"
	_tmp18_ = g_network_monitor_get_default ();
#line 68 "../src/Widgets/NetworkInfoBar.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 68 "../src/Widgets/NetworkInfoBar.vala"
	network_monitor = _tmp19_;
#line 69 "../src/Widgets/NetworkInfoBar.vala"
	_tmp20_ = network_monitor;
#line 69 "../src/Widgets/NetworkInfoBar.vala"
	g_signal_connect_object (_tmp20_, "network-changed", (GCallback) __network_info_bar___lambda21__g_network_monitor_network_changed, self, 0);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	_g_object_unref0 (network_monitor);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	_g_object_unref0 (never_button);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	_g_object_unref0 (default_label);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	_g_free0 (details);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	_g_free0 (title);
#line 30 "../src/Widgets/NetworkInfoBar.vala"
	return obj;
#line 399 "NetworkInfoBar.c"
}

static void
network_info_bar_class_init (NetworkInfoBarClass * klass,
                             gpointer klass_data)
{
#line 22 "../src/Widgets/NetworkInfoBar.vala"
	network_info_bar_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/NetworkInfoBar.vala"
	G_OBJECT_CLASS (klass)->constructor = network_info_bar_constructor;
#line 410 "NetworkInfoBar.c"
}

static void
network_info_bar_instance_init (NetworkInfoBar * self,
                                gpointer klass)
{
}

GType
network_info_bar_get_type (void)
{
	static volatile gsize network_info_bar_type_id__volatile = 0;
	if (g_once_init_enter (&network_info_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkInfoBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_info_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkInfoBar), 0, (GInstanceInitFunc) network_info_bar_instance_init, NULL };
		GType network_info_bar_type_id;
		network_info_bar_type_id = g_type_register_static (gtk_info_bar_get_type (), "NetworkInfoBar", &g_define_type_info, 0);
		g_once_init_leave (&network_info_bar_type_id__volatile, network_info_bar_type_id);
	}
	return network_info_bar_type_id__volatile;
}

