/* UrlEntry.c generated by valac 0.44.3, the Vala compiler
 * generated from UrlEntry.vala, do not modify */

/*
* Copyright © 2019 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <webkit2/webkit2.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <gdk/gdk.h>

#define TYPE_URL_ENTRY (url_entry_get_type ())
#define URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_URL_ENTRY, UrlEntry))
#define URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_URL_ENTRY, UrlEntryClass))
#define IS_URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_URL_ENTRY))
#define IS_URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_URL_ENTRY))
#define URL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_URL_ENTRY, UrlEntryClass))

typedef struct _UrlEntry UrlEntry;
typedef struct _UrlEntryClass UrlEntryClass;
typedef struct _UrlEntryPrivate UrlEntryPrivate;
enum  {
	URL_ENTRY_0_PROPERTY,
	URL_ENTRY_WEB_VIEW_PROPERTY,
	URL_ENTRY_NUM_PROPERTIES
};
static GParamSpec* url_entry_properties[URL_ENTRY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))

struct _UrlEntry {
	GtkEntry parent_instance;
	UrlEntryPrivate * priv;
};

struct _UrlEntryClass {
	GtkEntryClass parent_class;
};

struct _UrlEntryPrivate {
	GtkListStore* _list_store;
	GtkTreeIter _iter;
	WebKitWebView* _web_view;
};

static gint UrlEntry_private_offset;
static gpointer url_entry_parent_class = NULL;
extern GSettings* ephemeral_settings;

GType url_entry_get_type (void) G_GNUC_CONST;
UrlEntry* url_entry_new (WebKitWebView* _web_view);
UrlEntry* url_entry_construct (GType object_type,
                               WebKitWebView* _web_view);
static void url_entry_add_suggestion (UrlEntry* self,
                               const gchar* domain,
                               const gchar* name,
                               const gchar* reason);
static GtkListStore* url_entry_get_list_store (UrlEntry* self);
static void url_entry_reset_suggestions (UrlEntry* self,
                                  gchar** favorites,
                                  gint favorites_length1);
static void url_entry_set_list_store (UrlEntry* self,
                               GtkListStore* value);
static void url_entry_set_secondary_icon (UrlEntry* self);
WebKitWebView* url_entry_get_web_view (UrlEntry* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void _vala_SoupURI_free (SoupURI* self);
static void url_entry_get_iter (UrlEntry* self,
                         GtkTreeIter * result);
static void url_entry_set_iter (UrlEntry* self,
                         GtkTreeIter * value);
void url_entry_set_web_view (UrlEntry* self,
                             WebKitWebView* value);
static GObject * url_entry_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void _url_entry___lambda4_ (UrlEntry* self);
static void __url_entry___lambda4__gtk_entry_activate (GtkEntry* _sender,
                                                gpointer self);
static gboolean _url_entry___lambda5_ (UrlEntry* self,
                                GdkEventFocus* event);
static gboolean __url_entry___lambda5__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self);
static gboolean _url_entry___lambda6_ (UrlEntry* self,
                                GdkEventFocus* event);
static gboolean __url_entry___lambda6__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                            GdkEventFocus* event,
                                                            gpointer self);
static void _url_entry___lambda7_ (UrlEntry* self,
                            GtkEntryIconPosition icon_pos,
                            GdkEventButton* event);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void __url_entry___lambda7__gtk_entry_icon_release (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEventButton* event,
                                                    gpointer self);
static void _url_entry___lambda8_ (UrlEntry* self,
                            WebKitWebView* source,
                            WebKitLoadEvent e);
static void __url_entry___lambda8__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                          WebKitLoadEvent load_event,
                                                          gpointer self);
static void url_entry_finalize (GObject * obj);
static void _vala_url_entry_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_url_entry_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
url_entry_get_instance_private (UrlEntry* self)
{
	return G_STRUCT_MEMBER_P (self, UrlEntry_private_offset);
}

UrlEntry*
url_entry_construct (GType object_type,
                     WebKitWebView* _web_view)
{
	UrlEntry * self = NULL;
#line 28 "../src/Widgets/UrlEntry.vala"
	g_return_val_if_fail (_web_view != NULL, NULL);
#line 29 "../src/Widgets/UrlEntry.vala"
	self = (UrlEntry*) g_object_new (object_type, "hexpand", TRUE, "web-view", _web_view, "width-request", 100, NULL);
#line 28 "../src/Widgets/UrlEntry.vala"
	return self;
#line 176 "UrlEntry.c"
}

UrlEntry*
url_entry_new (WebKitWebView* _web_view)
{
#line 28 "../src/Widgets/UrlEntry.vala"
	return url_entry_construct (TYPE_URL_ENTRY, _web_view);
#line 184 "UrlEntry.c"
}

static void
url_entry_add_suggestion (UrlEntry* self,
                          const gchar* domain,
                          const gchar* name,
                          const gchar* reason)
{
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gchar* description = NULL;
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	const gchar* _tmp6_;
#line 136 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (domain != NULL);
#line 141 "../src/Widgets/UrlEntry.vala"
	g_debug ("UrlEntry.vala:141: Adding %s to suggestions…", domain);
#line 143 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = self->priv->_list_store;
#line 143 "../src/Widgets/UrlEntry.vala"
	gtk_list_store_append (_tmp0_, &_tmp1_);
#line 143 "../src/Widgets/UrlEntry.vala"
	iter = _tmp1_;
#line 146 "../src/Widgets/UrlEntry.vala"
	if (name != NULL) {
#line 214 "UrlEntry.c"
		gchar* _tmp2_;
#line 147 "../src/Widgets/UrlEntry.vala"
		_tmp2_ = g_strdup_printf ("%s – %s", name, reason);
#line 147 "../src/Widgets/UrlEntry.vala"
		_g_free0 (description);
#line 147 "../src/Widgets/UrlEntry.vala"
		description = _tmp2_;
#line 222 "UrlEntry.c"
	} else {
		gchar* _tmp3_;
#line 149 "../src/Widgets/UrlEntry.vala"
		_tmp3_ = g_strdup (reason);
#line 149 "../src/Widgets/UrlEntry.vala"
		_g_free0 (description);
#line 149 "../src/Widgets/UrlEntry.vala"
		description = _tmp3_;
#line 231 "UrlEntry.c"
	}
#line 152 "../src/Widgets/UrlEntry.vala"
	_tmp4_ = self->priv->_list_store;
#line 152 "../src/Widgets/UrlEntry.vala"
	_tmp5_ = iter;
#line 152 "../src/Widgets/UrlEntry.vala"
	_tmp6_ = description;
#line 152 "../src/Widgets/UrlEntry.vala"
	gtk_list_store_set (_tmp4_, &_tmp5_, 0, domain, 1, _tmp6_, -1);
#line 136 "../src/Widgets/UrlEntry.vala"
	_g_free0 (description);
#line 243 "UrlEntry.c"
}

static void
url_entry_reset_suggestions (UrlEntry* self,
                             gchar** favorites,
                             gint favorites_length1)
{
	GtkListStore* _tmp0_;
	GtkListStore* _tmp2_;
	GtkListStore* _tmp3_;
	GtkEntryCompletion* completion = NULL;
	GtkEntryCompletion* _tmp4_;
	GtkEntryCompletion* _tmp5_;
	GtkEntryCompletion* _tmp6_;
	GtkEntryCompletion* _tmp7_;
	GtkListStore* _tmp8_;
	GtkEntryCompletion* _tmp9_;
	GtkEntryCompletion* _tmp10_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp11_;
	GtkEntryCompletion* _tmp12_;
	GtkCellRendererText* _tmp13_;
	GtkEntryCompletion* _tmp14_;
	GtkCellRendererText* _tmp15_;
#line 155 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Widgets/UrlEntry.vala"
	g_debug ("UrlEntry.vala:156: Resetting suggestions…");
#line 158 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = self->priv->_list_store;
#line 158 "../src/Widgets/UrlEntry.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_list_store_get_type ())) {
#line 276 "UrlEntry.c"
		GtkListStore* _tmp1_;
#line 159 "../src/Widgets/UrlEntry.vala"
		_tmp1_ = self->priv->_list_store;
#line 159 "../src/Widgets/UrlEntry.vala"
		gtk_list_store_clear (_tmp1_);
#line 282 "UrlEntry.c"
	}
#line 162 "../src/Widgets/UrlEntry.vala"
	_tmp2_ = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING, -1);
#line 162 "../src/Widgets/UrlEntry.vala"
	_tmp3_ = _tmp2_;
#line 162 "../src/Widgets/UrlEntry.vala"
	url_entry_set_list_store (self, _tmp3_);
#line 162 "../src/Widgets/UrlEntry.vala"
	_g_object_unref0 (_tmp3_);
#line 164 "../src/Widgets/UrlEntry.vala"
	_tmp4_ = gtk_entry_completion_new ();
#line 164 "../src/Widgets/UrlEntry.vala"
	completion = _tmp4_;
#line 165 "../src/Widgets/UrlEntry.vala"
	_tmp5_ = completion;
#line 165 "../src/Widgets/UrlEntry.vala"
	gtk_entry_completion_set_inline_completion (_tmp5_, TRUE);
#line 166 "../src/Widgets/UrlEntry.vala"
	_tmp6_ = completion;
#line 166 "../src/Widgets/UrlEntry.vala"
	gtk_entry_completion_set_minimum_key_length (_tmp6_, 3);
#line 167 "../src/Widgets/UrlEntry.vala"
	_tmp7_ = completion;
#line 167 "../src/Widgets/UrlEntry.vala"
	_tmp8_ = self->priv->_list_store;
#line 167 "../src/Widgets/UrlEntry.vala"
	gtk_entry_completion_set_model (_tmp7_, (GtkTreeModel*) _tmp8_);
#line 168 "../src/Widgets/UrlEntry.vala"
	_tmp9_ = completion;
#line 168 "../src/Widgets/UrlEntry.vala"
	gtk_entry_completion_set_text_column (_tmp9_, 0);
#line 170 "../src/Widgets/UrlEntry.vala"
	_tmp10_ = completion;
#line 170 "../src/Widgets/UrlEntry.vala"
	gtk_entry_set_completion ((GtkEntry*) self, _tmp10_);
#line 172 "../src/Widgets/UrlEntry.vala"
	_tmp11_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 172 "../src/Widgets/UrlEntry.vala"
	g_object_ref_sink (_tmp11_);
#line 172 "../src/Widgets/UrlEntry.vala"
	cell = _tmp11_;
#line 173 "../src/Widgets/UrlEntry.vala"
	_tmp12_ = completion;
#line 173 "../src/Widgets/UrlEntry.vala"
	_tmp13_ = cell;
#line 173 "../src/Widgets/UrlEntry.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp12_, (GtkCellRenderer*) _tmp13_, FALSE);
#line 174 "../src/Widgets/UrlEntry.vala"
	_tmp14_ = completion;
#line 174 "../src/Widgets/UrlEntry.vala"
	_tmp15_ = cell;
#line 174 "../src/Widgets/UrlEntry.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp14_, (GtkCellRenderer*) _tmp15_, "text", 1);
#line 336 "UrlEntry.c"
	{
		gchar** favorite_collection = NULL;
		gint favorite_collection_length1 = 0;
		gint _favorite_collection_size_ = 0;
		gint favorite_it = 0;
#line 176 "../src/Widgets/UrlEntry.vala"
		favorite_collection = favorites;
#line 176 "../src/Widgets/UrlEntry.vala"
		favorite_collection_length1 = favorites_length1;
#line 176 "../src/Widgets/UrlEntry.vala"
		for (favorite_it = 0; favorite_it < favorites_length1; favorite_it = favorite_it + 1) {
#line 348 "UrlEntry.c"
			gchar* _tmp16_;
			gchar* favorite = NULL;
#line 176 "../src/Widgets/UrlEntry.vala"
			_tmp16_ = g_strdup (favorite_collection[favorite_it]);
#line 176 "../src/Widgets/UrlEntry.vala"
			favorite = _tmp16_;
#line 355 "UrlEntry.c"
			{
				const gchar* _tmp17_;
#line 177 "../src/Widgets/UrlEntry.vala"
				_tmp17_ = favorite;
#line 177 "../src/Widgets/UrlEntry.vala"
				url_entry_add_suggestion (self, _tmp17_, NULL, _ ("Favorite website"));
#line 176 "../src/Widgets/UrlEntry.vala"
				_g_free0 (favorite);
#line 364 "UrlEntry.c"
			}
		}
	}
#line 180 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "247sports.com", "247Sports", _ ("Popular website"));
#line 181 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "6pm.com", "6pm", _ ("Popular website"));
#line 182 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "aa.com", "American Airlines", _ ("Popular website"));
#line 183 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "aarp.org", "AARP", _ ("Popular website"));
#line 184 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "abc.go.com", "ABC", _ ("Popular website"));
#line 185 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "abcnews.go.com", "ABC News", _ ("Popular website"));
#line 186 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "abs-cbnnews.com", "ABS-CBN News", _ ("Popular website"));
#line 187 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "accuweather.com", "AccuWeather", _ ("Popular website"));
#line 188 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "aclu.org", "American Civil Liberties Union", _ ("Popular website"));
#line 189 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ae.com", "American Eagle Outfitters", _ ("Popular website"));
#line 190 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "airbnb.com", "Airbnb", _ ("Popular website"));
#line 191 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "aliexpress.com", "AliExpress", _ ("Popular website"));
#line 192 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "allrecipes.com", "Allrecipes", _ ("Popular website"));
#line 193 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "amazon.com", "Amazon", _ ("Popular website"));
#line 194 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "amazon.co.uk", "Amazon.co.uk", _ ("Popular website"));
#line 195 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "americanexpress.com", "American Express", _ ("Popular website"));
#line 196 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ancestry.com", "Ancestry", _ ("Popular website"));
#line 197 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "androidcentral.com", "Android Central", _ ("Popular website"));
#line 198 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "androidpolice.com", "Android Police", _ ("Popular website"));
#line 199 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "answers.com", "Answers", _ ("Popular website"));
#line 200 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "aol.com", "AOL", _ ("Popular website"));
#line 201 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "appcenter.elementary.io", "elementary AppCenter", _ ("Popular website"));
#line 202 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "archive.org", "Internet Archive", _ ("Popular website"));
#line 203 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "arstechnica.com", "Ars Technica", _ ("Popular website"));
#line 204 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "att.com", "AT&T", _ ("Popular website"));
#line 205 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "audible.com", "Audible", _ ("Popular website"));
#line 206 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "autotrader.com", "Autotrader", _ ("Popular website"));
#line 207 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "azlyrics.com", "AZLyrics", _ ("Popular website"));
#line 208 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "babycenter.com", "BabyCenter", _ ("Popular website"));
#line 209 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "baidu.com", "Baidu", _ ("Popular website"));
#line 210 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bankofamerica.com", "Bank of America", _ ("Popular website"));
#line 211 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bankrate.com", "Bankrate", _ ("Popular website"));
#line 212 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "barclaycardus.com", "Barclays US", _ ("Popular website"));
#line 213 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "barnesandnoble.com", "Barnes & Noble", _ ("Popular website"));
#line 214 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bbc.com", "BBC", _ ("Popular website"));
#line 215 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bbc.co.uk", "BBC", _ ("Popular website"));
#line 216 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bedbathandbeyond.com", "Bed Bath & Beyond", _ ("Popular website"));
#line 217 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bestbuy.com", "Best Buy", _ ("Popular website"));
#line 218 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "betanews.com", "BetaNews", _ ("Popular website"));
#line 219 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bhphotovideo.com", "B&H Photo", _ ("Popular website"));
#line 220 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "biblegateway.com", "BibleGateway.com", _ ("Popular website"));
#line 221 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bing.com", "Bing", _ ("Popular website"));
#line 222 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bizjournals.com", "The Business Journals", _ ("Popular website"));
#line 223 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "blogger.com", "Blogger", _ ("Popular website"));
#line 224 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "blogspot.com", "Blogspot", _ ("Popular website"));
#line 225 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bloomberg.com", "Bloomberg", _ ("Popular website"));
#line 226 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bn.com", "Barnes & Noble", _ ("Popular website"));
#line 227 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "bodybuilding.com", "Bodybuilding.com", _ ("Popular website"));
#line 228 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "booking.com", "Booking.com", _ ("Popular website"));
#line 229 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "box.com", "Box", _ ("Popular website"));
#line 230 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "buffer.com", "Buffer", _ ("Popular website"));
#line 231 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "businessinsider.com", "Business Insider", _ ("Popular website"));
#line 232 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "buzzfeed.com", "Buzzfeed", _ ("Popular website"));
#line 233 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "capitalone360.com", "Capital One Bank", _ ("Popular website"));
#line 234 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "capitalone.com", "Capital One", _ ("Popular website"));
#line 235 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "careerbuilder.com", "CareerBuilder", _ ("Popular website"));
#line 236 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cars.com", "Cars.com", _ ("Popular website"));
#line 237 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cartoonnetwork.com", "Cartoon Network", _ ("Popular website"));
#line 238 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cash.app", "Cash App", _ ("Popular website"));
#line 239 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cassidyjames.com", "Cassidy James", _ ("Popular website"));
#line 240 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cbs.com", "CBS", _ ("Popular website"));
#line 241 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cbsnews.com", "CBS News", _ ("Popular website"));
#line 242 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cbssports.com", "CBS Sports", _ ("Popular website"));
#line 243 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "chase.com", "Chase", _ ("Popular website"));
#line 244 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "chicagotribune.com", "Chicago Tribune", _ ("Popular website"));
#line 245 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "chron.com", "The Houston Chronicle", _ ("Popular website"));
#line 246 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "citibankonline.com", "Banking with Citi", _ ("Popular website"));
#line 247 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "citi.com", "Citi", _ ("Popular website"));
#line 248 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cloudflare.com", "Cloudflare", _ ("Popular website"));
#line 249 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cnbc.com", "CNBC", _ ("Popular website"));
#line 250 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cnet.com", "CNET", _ ("Popular website"));
#line 251 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cnn.com", "CNN", _ ("Popular website"));
#line 252 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "comcast.net", "Comcast", _ ("Popular website"));
#line 253 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "comenity.net", "Comenity", _ ("Popular website"));
#line 254 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "consumerreports.org", "Consumer Reports", _ ("Popular website"));
#line 255 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "costco.com", "Costco", _ ("Popular website"));
#line 256 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "coupons.com", "Coupons.com", _ ("Popular website"));
#line 257 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cox.net", "Cox", _ ("Popular website"));
#line 258 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cracked.com", "Cracked.com", _ ("Popular website"));
#line 259 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "craigslist.org", "Craigslist", _ ("Popular website"));
#line 260 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "creditkarma.com", "Credit Karma", _ ("Popular website"));
#line 261 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "custhelp.com", "Oracle Service Cloud", _ ("Popular website"));
#line 262 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "cvs.com", "CVS", _ ("Popular website"));
#line 263 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dailykos.com", "Daily Kos", _ ("Popular website"));
#line 264 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dailymotion.com", "Dailymotion", _ ("Popular website"));
#line 265 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "danielfore.com", "Daniel Foré", _ ("Popular website"));
#line 266 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "deadspin.com", "Deadspin", _ ("Popular website"));
#line 267 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dell.com", "Dell", _ ("Popular website"));
#line 268 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "delta.com", "Delta Air Lines", _ ("Popular website"));
#line 269 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "deviantart.com", "DeviantArt", _ ("Popular website"));
#line 270 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dickssportinggoods.com", "DICK'S Sporting Goods", _ ("Popular website"));
#line 271 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dictionary.com", "Dictionary.com", _ ("Popular website"));
#line 272 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "digitalocean.com", "DigitalOcean", _ ("Popular website"));
#line 273 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "digitaltrends.com", "Digital Trends", _ ("Popular website"));
#line 274 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "diply.com", "Diply", _ ("Popular website"));
#line 275 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "directv.com", "DIRECTV", _ ("Popular website"));
#line 276 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "discovercard.com", "Discover", _ ("Popular website"));
#line 277 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "discover.com", "Discover", _ ("Popular website"));
#line 278 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "disney.com", "Disney.com", _ ("Popular website"));
#line 279 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "do.co", "DigitalOcean", _ ("Popular website"));
#line 280 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "docs.google.com", "Google Docs", _ ("Popular website"));
#line 281 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dominos.com", "Domino's", _ ("Popular website"));
#line 282 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "draftkings.com", "DraftKings", _ ("Popular website"));
#line 283 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dribbble.com", "Dribbble", _ ("Popular website"));
#line 284 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "drive.google.com", "Google Drive", _ ("Popular website"));
#line 285 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "dropbox.com", "Dropbox", _ ("Popular website"));
#line 286 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "drugs.com", "Drugs.com", _ ("Popular website"));
#line 287 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "duckduckgo.com", "DuckDuckGo", _ ("Popular website"));
#line 288 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "earthlink.net", "EarthLink", _ ("Popular website"));
#line 289 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ebates.com", "Ebates", _ ("Popular website"));
#line 290 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ebay.com", "eBay", _ ("Popular website"));
#line 291 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "edmunds.com", "Edmunds", _ ("Popular website"));
#line 292 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "eff.org", "Electronic Frontier Foundation", _ ("Popular website"));
#line 293 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ehow.com", "eHow", _ ("Popular website"));
#line 294 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "elementary.io", "elementary", _ ("Popular website"));
#line 295 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "engadget.com", "Engadget", _ ("Popular website"));
#line 296 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "eonline.com", "E! News", _ ("Popular website"));
#line 297 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "epicurious.com", "Epicurious", _ ("Popular website"));
#line 298 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "espn.go.com", "ESPN", _ ("Popular website"));
#line 299 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "etsy.com", "Etsy", _ ("Popular website"));
#line 300 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "eventbrite.com", "Eventbrite", _ ("Popular website"));
#line 301 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "evernote.com", "Evernote", _ ("Popular website"));
#line 302 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "evite.com", "Evite", _ ("Popular website"));
#line 303 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ew.com", "Entertainment Weekly", _ ("Popular website"));
#line 304 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "expedia.com", "Expedia", _ ("Popular website"));
#line 305 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "facebook.com", "Facebook", _ ("Popular website"));
#line 306 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fandango.com", "Fandango", _ ("Popular website"));
#line 307 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fanduel.com", "FanDuel", _ ("Popular website"));
#line 308 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fanfiction.net", "FanFiction", _ ("Popular website"));
#line 309 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fast.com", "Fast.com", _ ("Popular website"));
#line 310 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fedex.com", "FedEx", _ ("Popular website"));
#line 311 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "feedly.com", "Feedly", _ ("Popular website"));
#line 312 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fidelity.com", "Fidelity Investments", _ ("Popular website"));
#line 313 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fitbit.com", "Fitbit", _ ("Popular website"));
#line 314 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "flickr.com", "Flickr", _ ("Popular website"));
#line 315 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "food52.com", "Food52", _ ("Popular website"));
#line 316 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "foodnetwork.com", "Food Network", _ ("Popular website"));
#line 317 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "fool.com", "The Motley Fool", _ ("Popular website"));
#line 318 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "forbes.com", "Forbes", _ ("Popular website"));
#line 319 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "forever21.com", "Forever 21", _ ("Popular website"));
#line 320 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "frys.com", "Fry's Home Electronics", _ ("Popular website"));
#line 321 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gamefaqs.com", "GameFAQs", _ ("Popular website"));
#line 322 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gamespot.com", "GameSpot", _ ("Popular website"));
#line 323 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gamestop.com", "GameStop", _ ("Popular website"));
#line 324 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gap.com", "Gap", _ ("Popular website"));
#line 325 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gawker.com", "Gawker", _ ("Popular website"));
#line 326 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "genius.com", "Genius", _ ("Popular website"));
#line 327 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gettogether.community", "Get Together", _ ("Popular website"));
#line 328 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gfycat.com", "Gfycat", _ ("Popular website"));
#line 329 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "giphy.com", "Giphy", _ ("Popular website"));
#line 330 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "github.com", "GitHub", _ ("Popular website"));
#line 331 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gizmodo.com", "Gizmodo", _ ("Popular website"));
#line 332 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "glassdoor.com", "Glassdoor", _ ("Popular website"));
#line 333 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gmail.com", "Gmail", _ ("Popular website"));
#line 334 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "gofundme.com", "GoFundMe", _ ("Popular website"));
#line 335 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "goodhousekeeping.com", "Good Housekeeping", _ ("Popular website"));
#line 336 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "goodreads.com", "Goodreads", _ ("Popular website"));
#line 337 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "google.com", "Google", _ ("Popular website"));
#line 338 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "greatergood.com", "GreaterGood", _ ("Popular website"));
#line 339 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "groupon.com", "Groupon", _ ("Popular website"));
#line 340 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "harvard.edu", "Harvard University", _ ("Popular website"));
#line 341 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "healthcare.gov", "HealthCare.gov", _ ("Popular website"));
#line 342 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "hilton.com", "Hilton", _ ("Popular website"));
#line 343 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "hm.com", "H&M", _ ("Popular website"));
#line 344 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "homedepot.com", "The Home Depot", _ ("Popular website"));
#line 345 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "hootsuite.com", "Hootsuite", _ ("Popular website"));
#line 346 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "hotels.com", "Hotels.com", _ ("Popular website"));
#line 347 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "hotnewhiphop.com", "HotNewHipHop", _ ("Popular website"));
#line 348 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "houzz.com", "Houzz", _ ("Popular website"));
#line 349 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "hp.com", "HP", _ ("Popular website"));
#line 350 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "hsn.com", "HSN", _ ("Popular website"));
#line 351 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "huffingtonpost.com", "Huffington Post", _ ("Popular website"));
#line 352 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "icloud.com", "iCloud", _ ("Popular website"));
#line 353 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "iflscience.com", "IFLScience", _ ("Popular website"));
#line 354 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ign.com", "IGN", _ ("Popular website"));
#line 355 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ikea.com", "IKEA", _ ("Popular website"));
#line 356 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "imdb.com", "Internet Movie Database", _ ("Popular website"));
#line 357 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "imgur.com", "Imgur", _ ("Popular website"));
#line 358 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "indeed.com", "Indeed", _ ("Popular website"));
#line 359 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "independent.co.uk", "The Independent", _ ("Popular website"));
#line 360 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "indiatimes.com", "Indiatimes", _ ("Popular website"));
#line 361 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "indiegogo.com", "Indiegogo", _ ("Popular website"));
#line 362 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ind.ie", "Indie", _ ("Popular website"));
#line 363 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "instagram.com", "Instagram", _ ("Popular website"));
#line 364 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "instructables.com", "Instructables", _ ("Popular website"));
#line 365 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "intuit.com", "Intuit", _ ("Popular website"));
#line 366 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "io9.com", "io9", _ ("Popular website"));
#line 367 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "irs.gov", "Internal Revenue Service", _ ("Popular website"));
#line 368 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "jalopnik.com", "Jalopnik", _ ("Popular website"));
#line 369 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "jblive.tv", "Jupiter Broadcasting LIVE!", _ ("Popular website"));
#line 370 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "jcpenny.com", "JCPenny", _ ("Popular website"));
#line 371 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "jcrew.com", "J.Crew", _ ("Popular website"));
#line 372 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "jet.com", "Jet.com", _ ("Popular website"));
#line 373 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "jezebel.com", "Jezebel", _ ("Popular website"));
#line 374 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "joinmastodon.org", "The Mastodon Project", _ ("Popular website"));
#line 375 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "jupiterbroadcasting.com", "Jupiter Broadcasting", _ ("Popular website"));
#line 376 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "kbb.com", "Kelly Blue Book", _ ("Popular website"));
#line 377 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "kickstarter.com", "Kickstarter", _ ("Popular website"));
#line 378 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "kinja.com", "Kinja", _ ("Popular website"));
#line 379 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "kmart.com", "Kmart", _ ("Popular website"));
#line 380 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "kohls.com", "Khol's", _ ("Popular website"));
#line 381 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "kotaku.com", "Kotaku", _ ("Popular website"));
#line 382 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ksl.com", "KSL.com", _ ("Popular website"));
#line 383 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "landsend.com", "Lands' End", _ ("Popular website"));
#line 384 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "latimes.com", "LA Times", _ ("Popular website"));
#line 385 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "legacy.com", "Legacy.com", _ ("Popular website"));
#line 386 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "lego.com", "LEGO", _ ("Popular website"));
#line 387 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "lifehacker.com", "Lifehacker", _ ("Popular website"));
#line 388 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "linkedin.com", "LinkedIn", _ ("Popular website"));
#line 389 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "linuxacademy.com", "Linux Academy", _ ("Popular website"));
#line 390 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "linuxunplugged.com", "LINUX Unplugged", _ ("Popular website"));
#line 391 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "littlethings.com", "LittleThings", _ ("Popular website"));
#line 392 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "liveleak.com", "LiveLeak", _ ("Popular website"));
#line 393 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "livestrong.com", "Livestrong", _ ("Popular website"));
#line 394 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "livingsocial.com", "LivingSocial", _ ("Popular website"));
#line 395 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "llbean.com", "L.L.Bean", _ ("Popular website"));
#line 396 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "lunduke.com", "Bryan Lunduke", _ ("Popular website"));
#line 397 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "lowes.com", "Lowes", _ ("Popular website"));
#line 398 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "macys.com", "Macy's", _ ("Popular website"));
#line 399 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mailchimp.com", "Mailchimp", _ ("Popular website"));
#line 400 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mapquest.com", "MapQuest", _ ("Popular website"));
#line 401 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "marketwatch.com", "MarketWatch", _ ("Popular website"));
#line 402 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "marriott.com", "Marriott", _ ("Popular website"));
#line 403 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "marthastewart.com", "Martha Stewart", _ ("Popular website"));
#line 404 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mashable.com", "Mashable", _ ("Popular website"));
#line 405 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "match.com", "Match.com", _ ("Popular website"));
#line 406 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mayoclinic.org", "Mayo Clinic", _ ("Popular website"));
#line 407 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "medium.com", "Medium", _ ("Popular website"));
#line 408 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "meetup.com", "Meetup", _ ("Popular website"));
#line 409 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "merriam-webster.com", "Dictionary by Merriam-Webster", _ ("Popular website"));
#line 410 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mic.com", "Mic", _ ("Popular website"));
#line 411 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "michaels.com", "Michaels", _ ("Popular website"));
#line 412 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mint.com", "Mint", _ ("Popular website"));
#line 413 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mit.edu", "Massachusetts Institute of Technology", _ ("Popular website"));
#line 414 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mlb.com", "MLB", _ ("Popular website"));
#line 415 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "monster.com", "Monster Jobs", _ ("Popular website"));
#line 416 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "mozilla.org", "Mozilla", _ ("Popular website"));
#line 417 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "msnbc.com", "NBC News", _ ("Popular website"));
#line 418 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "msn.com", "Microsoft Live", _ ("Popular website"));
#line 419 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "myfitnesspal.com", "MyFitnessPal", _ ("Popular website"));
#line 420 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nationalgeographic.com", "National Geographic", _ ("Popular website"));
#line 421 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "naver.com", "NAVER", _ ("Popular website"));
#line 422 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nba.com", "NBA", _ ("Popular website"));
#line 423 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nbc.com", "NBC", _ ("Popular website"));
#line 424 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nbcnews.com", "NBC News", _ ("Popular website"));
#line 425 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nbcsports.com", "NBC Sports", _ ("Popular website"));
#line 426 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nesn.com", "NESN", _ ("Popular website"));
#line 427 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "newegg.com", "Newegg", _ ("Popular website"));
#line 428 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nextdoor.com", "Nextdoor", _ ("Popular website"));
#line 429 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nhl.com", "National Hockey League", _ ("Popular website"));
#line 430 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nih.gov", "National Institutes of Health", _ ("Popular website"));
#line 431 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nike.com", "Nike", _ ("Popular website"));
#line 432 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "noaa.gov", "National Oceanic and Atmospheric Administration", _ ("Popular website"));
#line 433 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nordstrom.com", "Nordstrom", _ ("Popular website"));
#line 434 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "npr.org", "NPR", _ ("Popular website"));
#line 435 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ny.gov", "New York State", _ ("Popular website"));
#line 436 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nypost.com", "New York Post", _ ("Popular website"));
#line 437 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "nytimes.com", "New York Times", _ ("Popular website"));
#line 438 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "office365.com", "Office 365", _ ("Popular website"));
#line 439 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "officedepot.com", "Office Depot & OfficeMax", _ ("Popular website"));
#line 440 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "okcupid.com", "OKCupid", _ ("Popular website"));
#line 441 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "omgubuntu.co.uk", "OMG! Ubuntu!", _ ("Popular website"));
#line 442 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "opentable.com", "OpenTable", _ ("Popular website"));
#line 443 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "oracle.com", "Oracle", _ ("Popular website"));
#line 444 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "orbitz.com", "Orbitz", _ ("Popular website"));
#line 445 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "overstock.com", "Overstock", _ ("Popular website"));
#line 446 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "pandora.com", "Pandora", _ ("Popular website"));
#line 447 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "patch.com", "Patch", _ ("Popular website"));
#line 448 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "patheos.com", "Patheos", _ ("Popular website"));
#line 449 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "paypal.com", "PayPal", _ ("Popular website"));
#line 450 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "pbs.org", "Public Broadcasting Service", _ ("Popular website"));
#line 451 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "pcmag.com", "PCMag.com", _ ("Popular website"));
#line 452 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "people.com", "PEOPLE", _ ("Popular website"));
#line 453 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "phoronix.com", "Phoronix", _ ("Popular website"));
#line 454 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "pinterest.com", "Pinterest", _ ("Popular website"));
#line 455 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "playstation.com", "PlayStation", _ ("Popular website"));
#line 456 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "pnc.com", "PNC", _ ("Popular website"));
#line 457 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "pof.com", "POF", _ ("Popular website"));
#line 458 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "pogo.com", "Pogo.com", _ ("Popular website"));
#line 459 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "politico.com", "POLITICO", _ ("Popular website"));
#line 460 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "popsugar.com", "POPSUGAR", _ ("Popular website"));
#line 461 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "potterybarn.com", "Pottery Barn", _ ("Popular website"));
#line 462 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "priceline.com", "Priceline", _ ("Popular website"));
#line 463 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "purdue.edu", "Purdue University", _ ("Popular website"));
#line 464 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "puri.sm", "Purism", _ ("Popular website"));
#line 465 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "qq.com", "QQ.com", _ ("Popular website"));
#line 466 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "qualtrics.com", "Qualtrics", _ ("Popular website"));
#line 467 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "quizlet.com", "Quizlet", _ ("Popular website"));
#line 468 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "quora.com", "Quora", _ ("Popular website"));
#line 469 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "qvc.com", "QVC", _ ("Popular website"));
#line 470 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ravelry.com", "Ravelry", _ ("Popular website"));
#line 471 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "realsimple.com", "Real Simple", _ ("Popular website"));
#line 472 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "realtor.com", "Realtor.com", _ ("Popular website"));
#line 473 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "redbox.com", "Redbox", _ ("Popular website"));
#line 474 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "reddit.com", "Reddit", _ ("Popular website"));
#line 475 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "redfin.com", "Redfin", _ ("Popular website"));
#line 476 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "refactoringui.com", "Refactoring UI", _ ("Popular website"));
#line 477 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "reference.com", "Reference.com", _ ("Popular website"));
#line 478 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "refinery29.com", "Refinery29", _ ("Popular website"));
#line 479 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "rei.com", "REI", _ ("Popular website"));
#line 480 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "retailmenot.com", "RetailMeNot", _ ("Popular website"));
#line 481 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "reuters.com", "Reuters", _ ("Popular website"));
#line 482 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "roblox.com", "Roblox", _ ("Popular website"));
#line 483 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "rollingstone.com", "Rolling Stone", _ ("Popular website"));
#line 484 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "rotoworld.com", "Rotoworld", _ ("Popular website"));
#line 485 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "rottentomatoes.com", "Rotten Tomatoes", _ ("Popular website"));
#line 486 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "salesforce.com", "Salesforce", _ ("Popular website"));
#line 487 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "salon.com", "Salon.com", _ ("Popular website"));
#line 488 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "samsclub.com", "Sam's Club", _ ("Popular website"));
#line 489 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sbnation.com", "SBNation", _ ("Popular website"));
#line 490 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "schwab.com", "Charles Schwab", _ ("Popular website"));
#line 491 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sears.com", "Sears", _ ("Popular website"));
#line 492 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sephora.com", "Sephora", _ ("Popular website"));
#line 493 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sfgate.com", "SFGATE", _ ("Popular website"));
#line 494 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sharepoint.com", "SharePoint", _ ("Popular website"));
#line 495 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sheets.google.com", "Google Sheets", _ ("Popular website"));
#line 496 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "shopify.com", "Shopify", _ ("Popular website"));
#line 497 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "shutterfly.com", "Shutterfly", _ ("Popular website"));
#line 498 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "si.com", "Sports Illustrated", _ ("Popular website"));
#line 499 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "simple.com", "Simple", _ ("Popular website"));
#line 500 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "skype.com", "Skype", _ ("Popular website"));
#line 501 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "slate.com", "Slate", _ ("Popular website"));
#line 502 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "slides.google.com", "Google Slides", _ ("Popular website"));
#line 503 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "slideshare.net", "SlideShare", _ ("Popular website"));
#line 504 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "slimbook.es", "SLIMBOOK", _ ("Popular website"));
#line 505 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "soundcloud.com", "SoundCloud", _ ("Popular website"));
#line 506 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sourceforge.net", "SourceForge", _ ("Popular website"));
#line 507 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "southwest.com", "Southwest Airlines", _ ("Popular website"));
#line 508 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "spectrum.com", "Spectrum", _ ("Popular website"));
#line 509 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "speedtest.net", "Speedtest", _ ("Popular website"));
#line 510 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "sprint.com", "Sprint", _ ("Popular website"));
#line 511 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "squarespace.com", "Squarespace", _ ("Popular website"));
#line 512 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "squareup.com", "Square", _ ("Popular website"));
#line 513 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "stackoverflow.com", "Stack Overflow", _ ("Popular website"));
#line 514 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "stanford.edu", "Stanford University", _ ("Popular website"));
#line 515 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "staples.com", "Staples", _ ("Popular website"));
#line 516 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "starbucks.com", "Starbucks", _ ("Popular website"));
#line 517 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "startpage.com", "Startpage.com", _ ("Popular website"));
#line 518 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "steamcommunity.com", "Steam Community", _ ("Popular website"));
#line 519 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "steampowered.com", "Steam", _ ("Popular website"));
#line 520 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "stripe.com", "Stripe", _ ("Popular website"));
#line 521 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "stubhub.com", "StubHub", _ ("Popular website"));
#line 522 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "surveymonkey.com", "SurveyMonkey", _ ("Popular website"));
#line 523 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "swagbucks.com", "Swagbucks", _ ("Popular website"));
#line 524 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "system76.com", "System76", _ ("Popular website"));
#line 525 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "taobao.com", "Taobao", _ ("Popular website"));
#line 526 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "target.com", "Target", _ ("Popular website"));
#line 527 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tdbank.com", "TD Bank", _ ("Popular website"));
#line 528 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "techcrunch.com", "TechCrunch", _ ("Popular website"));
#line 529 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "telegraph.co.uk", "The Telegraph", _ ("Popular website"));
#line 530 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "theatlantic.com", "The Atlantic", _ ("Popular website"));
#line 531 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "thefreedictionary.com", "The Free Dictionary", _ ("Popular website"));
#line 532 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "theguardian.com", "The Guardian", _ ("Popular website"));
#line 533 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "thekitchn.com", "Kitchn", _ ("Popular website"));
#line 534 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "theonion.com", "The Onion", _ ("Popular website"));
#line 535 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "theoutline.com", "The Outline", _ ("Popular website"));
#line 536 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "theregister.co.uk", "The Register", _ ("Popular website"));
#line 537 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "thesaurus.com", "Thesaurus.com", _ ("Popular website"));
#line 538 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "theverge.com", "The Verge", _ ("Popular website"));
#line 539 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "thinkgeek.com", "ThinkGeek", _ ("Popular website"));
#line 540 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ticketmaster.com", "Ticketmaster", _ ("Popular website"));
#line 541 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tickld.com", "tickld.com", _ ("Popular website"));
#line 542 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tigerdirect.com", "TigerDirect.com", _ ("Popular website"));
#line 543 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "timeanddate.com", "timeanddate.com", _ ("Popular website"));
#line 544 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "time.com", "TIME", _ ("Popular website"));
#line 545 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "timewarnercable.com", "Spectrum", _ ("Popular website"));
#line 546 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "t-mobile.com", "T-Mobile", _ ("Popular website"));
#line 547 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tmobile.com", "T-Mobile", _ ("Popular website"));
#line 548 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tmz.com", "TMZ", _ ("Popular website"));
#line 549 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "today.com", "TODAY", _ ("Popular website"));
#line 550 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tomshardware.com", "Tom's Hardware", _ ("Popular website"));
#line 551 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "topix.com", "Topix", _ ("Popular website"));
#line 552 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tripadvisor.com", "TripAdvisor", _ ("Popular website"));
#line 553 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "trulia.com", "Trulia", _ ("Popular website"));
#line 554 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tumblr.com", "Tumblr", _ ("Popular website"));
#line 555 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "tvguide.com", "TV Guide", _ ("Popular website"));
#line 556 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "twitch.tv", "Twitch", _ ("Popular website"));
#line 557 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ulta.com", "Ulta Beauty", _ ("Popular website"));
#line 558 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "united.com", "United Airlines", _ ("Popular website"));
#line 559 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "unsplash.com", "Unsplash", _ ("Popular website"));
#line 560 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "ups.com", "UPS", _ ("Popular website"));
#line 561 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "urbandictionary.com", "Urban Dictionary", _ ("Popular website"));
#line 562 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "urbanoutfitters.com", "Urban Outfitters", _ ("Popular website"));
#line 563 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "usaa.com", "USAA", _ ("Popular website"));
#line 564 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "usatoday.com", "USA Today", _ ("Popular website"));
#line 565 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "usbank.com", "US Bank", _ ("Popular website"));
#line 566 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "usmagazine.com", "Us Weekly", _ ("Popular website"));
#line 567 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "usnews.com", "US News & World Report", _ ("Popular website"));
#line 568 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "usps.com", "USPS", _ ("Popular website"));
#line 569 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "valadoc.org", "Valadoc", _ ("Popular website"));
#line 570 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "vanguard.com", "Vanguard", _ ("Popular website"));
#line 571 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "verizon.com", "Verizon", _ ("Popular website"));
#line 572 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "vice.com", "VICE", _ ("Popular website"));
#line 573 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "vimeo.com", "Vimeo", _ ("Popular website"));
#line 574 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "vistaprint.com", "Vistaprint", _ ("Popular website"));
#line 575 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "vox.com", "Vox", _ ("Popular website"));
#line 576 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "vrbo.com", "VRBO.com", _ ("Popular website"));
#line 577 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "walgreens.com", "Walgreens", _ ("Popular website"));
#line 578 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "walmart.com", "Walmart", _ ("Popular website"));
#line 579 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "washingtonpost.com", "Washington Post", _ ("Popular website"));
#line 580 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wayfair.com", "Wayfair", _ ("Popular website"));
#line 581 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "weather.com", "Weather", _ ("Popular website"));
#line 582 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "weather.gov", "National Weather Service", _ ("Popular website"));
#line 583 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "webex.com", "Cisco Webex", _ ("Popular website"));
#line 584 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "webmd.com", "WebMD", _ ("Popular website"));
#line 585 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "weebly.com", "Weebly", _ ("Popular website"));
#line 586 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wellsfargo.com", "Wells Fargo", _ ("Popular website"));
#line 587 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "whitepages.com", "Whitepages", _ ("Popular website"));
#line 588 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wikia.com", "Wikia", _ ("Popular website"));
#line 589 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wikihow.com", "wikiHow", _ ("Popular website"));
#line 590 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wikimedia.org", "Wikimedia", _ ("Popular website"));
#line 591 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wikipedia.org", "Wikipedia", _ ("Popular website"));
#line 592 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wired.com", "WIRED", _ ("Popular website"));
#line 593 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wix.com", "Wix", _ ("Popular website"));
#line 594 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "woot.com", "Woot", _ ("Popular website"));
#line 595 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wordpress.com", "Wordpress", _ ("Popular website"));
#line 596 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wsj.com", "Wall Street Journal", _ ("Popular website"));
#line 597 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "wunderground.com", "Weather Underground", _ ("Popular website"));
#line 598 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "xbox.com", "Xbox", _ ("Popular website"));
#line 599 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "xfinity.com", "Xfinity", _ ("Popular website"));
#line 600 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "xkcd.com", "xkcd", _ ("Popular website"));
#line 601 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "yahoo.com", "Yahoo", _ ("Popular website"));
#line 602 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "yellowpages.com", "Yellowpages", _ ("Popular website"));
#line 603 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "yelp.com", "Yelp", _ ("Popular website"));
#line 604 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "youtube.com", "YouTube", _ ("Popular website"));
#line 605 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "zappos.com", "Zappos", _ ("Popular website"));
#line 606 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "zazzle.com", "Zazzle", _ ("Popular website"));
#line 607 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "zendesk.com", "Zendesk", _ ("Popular website"));
#line 608 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "zergnet.com", "ZergNet", _ ("Popular website"));
#line 609 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "zillow.com", "Zillow", _ ("Popular website"));
#line 610 "../src/Widgets/UrlEntry.vala"
	url_entry_add_suggestion (self, "zulily.com", "Zulily", _ ("Popular website"));
#line 155 "../src/Widgets/UrlEntry.vala"
	_g_object_unref0 (cell);
#line 155 "../src/Widgets/UrlEntry.vala"
	_g_object_unref0 (completion);
#line 1234 "UrlEntry.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
#line 625 "../src/Widgets/UrlEntry.vala"
	for (i = 0; i < stack_length; i++) {
#line 625 "../src/Widgets/UrlEntry.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 625 "../src/Widgets/UrlEntry.vala"
			return TRUE;
#line 1249 "UrlEntry.c"
		}
	}
#line 625 "../src/Widgets/UrlEntry.vala"
	return FALSE;
#line 1254 "UrlEntry.c"
}

static void
_vala_SoupURI_free (SoupURI* self)
{
#line 614 "../src/Widgets/UrlEntry.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 1262 "UrlEntry.c"
}

static void
url_entry_set_secondary_icon (UrlEntry* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 613 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (self != NULL);
#line 614 "../src/Widgets/UrlEntry.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 614 "../src/Widgets/UrlEntry.vala"
	_tmp2_ = _tmp1_;
#line 614 "../src/Widgets/UrlEntry.vala"
	if (_tmp2_) {
#line 614 "../src/Widgets/UrlEntry.vala"
		_tmp0_ = TRUE;
#line 1281 "UrlEntry.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 614 "../src/Widgets/UrlEntry.vala"
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) self);
#line 614 "../src/Widgets/UrlEntry.vala"
		_tmp4_ = _tmp3_;
#line 614 "../src/Widgets/UrlEntry.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "") == 0;
#line 1291 "UrlEntry.c"
	}
#line 614 "../src/Widgets/UrlEntry.vala"
	if (_tmp0_) {
#line 1295 "UrlEntry.c"
		gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 615 "../src/Widgets/UrlEntry.vala"
		g_object_set ((GtkEntry*) self, "secondary-icon-name", "go-jump-symbolic", NULL);
#line 616 "../src/Widgets/UrlEntry.vala"
		g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-text", _ ("Go"), NULL);
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp5_ = g_strdup ("Return");
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp6_ = g_new0 (gchar*, 1 + 1);
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp6_[0] = _tmp5_;
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp7_ = _tmp6_;
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp7__length1 = 1;
#line 617 "../src/Widgets/UrlEntry.vala"
		g_object_get ((GtkEntry*) self, "secondary-icon-tooltip-text", &_tmp8_, NULL);
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp9_ = _tmp8_;
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp10_ = _tmp9_;
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp11_ = granite_markup_accel_tooltip (_tmp7_, (gint) 1, _tmp10_);
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp12_ = _tmp11_;
#line 617 "../src/Widgets/UrlEntry.vala"
		g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-markup", _tmp12_, NULL);
#line 617 "../src/Widgets/UrlEntry.vala"
		_g_free0 (_tmp12_);
#line 617 "../src/Widgets/UrlEntry.vala"
		_g_free0 (_tmp10_);
#line 617 "../src/Widgets/UrlEntry.vala"
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 1337 "UrlEntry.c"
	} else {
		gchar** current_favorites = NULL;
		GSettings* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint current_favorites_length1;
		gint _current_favorites_size_;
		SoupURI* uri = NULL;
		WebKitWebView* _tmp16_;
		const gchar* _tmp17_;
		SoupURI* _tmp18_;
		SoupURI* _tmp19_;
#line 619 "../src/Widgets/UrlEntry.vala"
		_tmp13_ = ephemeral_settings;
#line 619 "../src/Widgets/UrlEntry.vala"
		_tmp15_ = _tmp14_ = g_settings_get_strv (_tmp13_, "favorite-websites");
#line 619 "../src/Widgets/UrlEntry.vala"
		current_favorites = _tmp15_;
#line 619 "../src/Widgets/UrlEntry.vala"
		current_favorites_length1 = _vala_array_length (_tmp14_);
#line 619 "../src/Widgets/UrlEntry.vala"
		_current_favorites_size_ = current_favorites_length1;
#line 620 "../src/Widgets/UrlEntry.vala"
		_tmp16_ = self->priv->_web_view;
#line 620 "../src/Widgets/UrlEntry.vala"
		_tmp17_ = webkit_web_view_get_uri (_tmp16_);
#line 620 "../src/Widgets/UrlEntry.vala"
		_tmp18_ = soup_uri_new (_tmp17_);
#line 620 "../src/Widgets/UrlEntry.vala"
		uri = _tmp18_;
#line 622 "../src/Widgets/UrlEntry.vala"
		_tmp19_ = uri;
#line 622 "../src/Widgets/UrlEntry.vala"
		if (_tmp19_ != NULL) {
#line 1372 "UrlEntry.c"
			gchar* domain = NULL;
			SoupURI* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			const gchar* _tmp23_;
			gchar** _tmp24_;
			gint _tmp24__length1;
#line 623 "../src/Widgets/UrlEntry.vala"
			_tmp20_ = uri;
#line 623 "../src/Widgets/UrlEntry.vala"
			_tmp21_ = soup_uri_get_host (_tmp20_);
#line 623 "../src/Widgets/UrlEntry.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 623 "../src/Widgets/UrlEntry.vala"
			domain = _tmp22_;
#line 625 "../src/Widgets/UrlEntry.vala"
			_tmp23_ = domain;
#line 625 "../src/Widgets/UrlEntry.vala"
			_tmp24_ = current_favorites;
#line 625 "../src/Widgets/UrlEntry.vala"
			_tmp24__length1 = current_favorites_length1;
#line 625 "../src/Widgets/UrlEntry.vala"
			if (_vala_string_array_contains (_tmp24_, _tmp24__length1, _tmp23_)) {
#line 1396 "UrlEntry.c"
				const gchar* _tmp25_;
#line 626 "../src/Widgets/UrlEntry.vala"
				_tmp25_ = domain;
#line 626 "../src/Widgets/UrlEntry.vala"
				g_debug ("UrlEntry.vala:626: %s is a favorite, showing filled star.", _tmp25_);
#line 627 "../src/Widgets/UrlEntry.vala"
				g_object_set ((GtkEntry*) self, "secondary-icon-name", "starred", NULL);
#line 628 "../src/Widgets/UrlEntry.vala"
				g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-text", _ ("Remove Website from Suggestions"), NULL);
#line 1406 "UrlEntry.c"
			} else {
				const gchar* _tmp26_;
#line 630 "../src/Widgets/UrlEntry.vala"
				_tmp26_ = domain;
#line 630 "../src/Widgets/UrlEntry.vala"
				g_debug ("UrlEntry.vala:630: %s is not a favorite, showing empty star.", _tmp26_);
#line 631 "../src/Widgets/UrlEntry.vala"
				g_object_set ((GtkEntry*) self, "secondary-icon-name", "non-starred-symbolic", NULL);
#line 632 "../src/Widgets/UrlEntry.vala"
				g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-text", _ ("Add Website to Suggestions"), NULL);
#line 1417 "UrlEntry.c"
			}
#line 622 "../src/Widgets/UrlEntry.vala"
			_g_free0 (domain);
#line 1421 "UrlEntry.c"
		}
#line 614 "../src/Widgets/UrlEntry.vala"
		__vala_SoupURI_free0 (uri);
#line 614 "../src/Widgets/UrlEntry.vala"
		current_favorites = (_vala_array_free (current_favorites, current_favorites_length1, (GDestroyNotify) g_free), NULL);
#line 1427 "UrlEntry.c"
	}
}

static GtkListStore*
url_entry_get_list_store (UrlEntry* self)
{
	GtkListStore* result;
	GtkListStore* _tmp0_;
#line 23 "../src/Widgets/UrlEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = self->priv->_list_store;
#line 23 "../src/Widgets/UrlEntry.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/UrlEntry.vala"
	return result;
#line 1444 "UrlEntry.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/Widgets/UrlEntry.vala"
	return self ? g_object_ref (self) : NULL;
#line 1452 "UrlEntry.c"
}

static void
url_entry_set_list_store (UrlEntry* self,
                          GtkListStore* value)
{
	GtkListStore* _tmp0_;
#line 23 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/UrlEntry.vala"
	_g_object_unref0 (self->priv->_list_store);
#line 23 "../src/Widgets/UrlEntry.vala"
	self->priv->_list_store = _tmp0_;
#line 1468 "UrlEntry.c"
}

static void
url_entry_get_iter (UrlEntry* self,
                    GtkTreeIter * result)
{
	GtkTreeIter _tmp0_;
#line 24 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = self->priv->_iter;
#line 24 "../src/Widgets/UrlEntry.vala"
	*result = _tmp0_;
#line 24 "../src/Widgets/UrlEntry.vala"
	return;
#line 1484 "UrlEntry.c"
}

static void
url_entry_set_iter (UrlEntry* self,
                    GtkTreeIter * value)
{
	GtkTreeIter _tmp0_;
#line 24 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = *value;
#line 24 "../src/Widgets/UrlEntry.vala"
	self->priv->_iter = _tmp0_;
#line 1498 "UrlEntry.c"
}

WebKitWebView*
url_entry_get_web_view (UrlEntry* self)
{
	WebKitWebView* result;
	WebKitWebView* _tmp0_;
#line 26 "../src/Widgets/UrlEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = self->priv->_web_view;
#line 26 "../src/Widgets/UrlEntry.vala"
	result = _tmp0_;
#line 26 "../src/Widgets/UrlEntry.vala"
	return result;
#line 1514 "UrlEntry.c"
}

void
url_entry_set_web_view (UrlEntry* self,
                        WebKitWebView* value)
{
#line 26 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/UrlEntry.vala"
	if (url_entry_get_web_view (self) != value) {
#line 1525 "UrlEntry.c"
		WebKitWebView* _tmp0_;
#line 26 "../src/Widgets/UrlEntry.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/Widgets/UrlEntry.vala"
		_g_object_unref0 (self->priv->_web_view);
#line 26 "../src/Widgets/UrlEntry.vala"
		self->priv->_web_view = _tmp0_;
#line 26 "../src/Widgets/UrlEntry.vala"
		g_object_notify_by_pspec ((GObject *) self, url_entry_properties[URL_ENTRY_WEB_VIEW_PROPERTY]);
#line 1535 "UrlEntry.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 1560 "UrlEntry.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 1579 "UrlEntry.c"
}

static void
_url_entry___lambda4_ (UrlEntry* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* search_engine = NULL;
	GSettings* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	WebKitWebView* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	WebKitWebView* _tmp30_;
#line 51 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = gtk_entry_get_text ((GtkEntry*) self);
#line 51 "../src/Widgets/UrlEntry.vala"
	_tmp1_ = _tmp0_;
#line 51 "../src/Widgets/UrlEntry.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 51 "../src/Widgets/UrlEntry.vala"
	_tmp3_ = _tmp2_;
#line 51 "../src/Widgets/UrlEntry.vala"
	gtk_entry_set_text ((GtkEntry*) self, _tmp3_);
#line 51 "../src/Widgets/UrlEntry.vala"
	_g_free0 (_tmp3_);
#line 52 "../src/Widgets/UrlEntry.vala"
	_tmp4_ = ephemeral_settings;
#line 52 "../src/Widgets/UrlEntry.vala"
	_tmp5_ = g_settings_get_string (_tmp4_, "search-engine");
#line 52 "../src/Widgets/UrlEntry.vala"
	search_engine = _tmp5_;
#line 55 "../src/Widgets/UrlEntry.vala"
	_tmp7_ = gtk_entry_get_text ((GtkEntry*) self);
#line 55 "../src/Widgets/UrlEntry.vala"
	_tmp8_ = _tmp7_;
#line 55 "../src/Widgets/UrlEntry.vala"
	if (g_strcmp0 (_tmp8_, "") == 0) {
#line 55 "../src/Widgets/UrlEntry.vala"
		_tmp6_ = TRUE;
#line 1625 "UrlEntry.c"
	} else {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 55 "../src/Widgets/UrlEntry.vala"
		_tmp9_ = gtk_entry_get_text ((GtkEntry*) self);
#line 55 "../src/Widgets/UrlEntry.vala"
		_tmp10_ = _tmp9_;
#line 55 "../src/Widgets/UrlEntry.vala"
		_tmp6_ = _tmp10_ == NULL;
#line 1635 "UrlEntry.c"
	}
#line 55 "../src/Widgets/UrlEntry.vala"
	if (_tmp6_) {
#line 56 "../src/Widgets/UrlEntry.vala"
		gdk_beep ();
#line 57 "../src/Widgets/UrlEntry.vala"
		_g_free0 (search_engine);
#line 57 "../src/Widgets/UrlEntry.vala"
		return;
#line 1645 "UrlEntry.c"
	} else {
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 58 "../src/Widgets/UrlEntry.vala"
		_tmp11_ = gtk_entry_get_text ((GtkEntry*) self);
#line 58 "../src/Widgets/UrlEntry.vala"
		_tmp12_ = _tmp11_;
#line 58 "../src/Widgets/UrlEntry.vala"
		if (!string_contains (_tmp12_, "://")) {
#line 1655 "UrlEntry.c"
			gboolean _tmp13_ = FALSE;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
#line 59 "../src/Widgets/UrlEntry.vala"
			_tmp14_ = gtk_entry_get_text ((GtkEntry*) self);
#line 59 "../src/Widgets/UrlEntry.vala"
			_tmp15_ = _tmp14_;
#line 59 "../src/Widgets/UrlEntry.vala"
			if (string_contains (_tmp15_, ".")) {
#line 1665 "UrlEntry.c"
				const gchar* _tmp16_;
				const gchar* _tmp17_;
#line 59 "../src/Widgets/UrlEntry.vala"
				_tmp16_ = gtk_entry_get_text ((GtkEntry*) self);
#line 59 "../src/Widgets/UrlEntry.vala"
				_tmp17_ = _tmp16_;
#line 59 "../src/Widgets/UrlEntry.vala"
				_tmp13_ = !string_contains (_tmp17_, " ");
#line 1674 "UrlEntry.c"
			} else {
#line 59 "../src/Widgets/UrlEntry.vala"
				_tmp13_ = FALSE;
#line 1678 "UrlEntry.c"
			}
#line 59 "../src/Widgets/UrlEntry.vala"
			if (_tmp13_) {
#line 1682 "UrlEntry.c"
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 61 "../src/Widgets/UrlEntry.vala"
				_tmp18_ = gtk_entry_get_text ((GtkEntry*) self);
#line 61 "../src/Widgets/UrlEntry.vala"
				_tmp19_ = _tmp18_;
#line 61 "../src/Widgets/UrlEntry.vala"
				_tmp20_ = g_strdup_printf ("%s://%s", "http", _tmp19_);
#line 61 "../src/Widgets/UrlEntry.vala"
				_tmp21_ = _tmp20_;
#line 61 "../src/Widgets/UrlEntry.vala"
				gtk_entry_set_text ((GtkEntry*) self, _tmp21_);
#line 61 "../src/Widgets/UrlEntry.vala"
				_g_free0 (_tmp21_);
#line 1699 "UrlEntry.c"
			} else {
				const gchar* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
#line 63 "../src/Widgets/UrlEntry.vala"
				_tmp22_ = search_engine;
#line 63 "../src/Widgets/UrlEntry.vala"
				_tmp23_ = gtk_entry_get_text ((GtkEntry*) self);
#line 63 "../src/Widgets/UrlEntry.vala"
				_tmp24_ = _tmp23_;
#line 63 "../src/Widgets/UrlEntry.vala"
				_tmp25_ = g_strdup_printf (_tmp22_, _tmp24_);
#line 63 "../src/Widgets/UrlEntry.vala"
				_tmp26_ = _tmp25_;
#line 63 "../src/Widgets/UrlEntry.vala"
				gtk_entry_set_text ((GtkEntry*) self, _tmp26_);
#line 63 "../src/Widgets/UrlEntry.vala"
				_g_free0 (_tmp26_);
#line 1720 "UrlEntry.c"
			}
		}
	}
#line 66 "../src/Widgets/UrlEntry.vala"
	_tmp27_ = self->priv->_web_view;
#line 66 "../src/Widgets/UrlEntry.vala"
	_tmp28_ = gtk_entry_get_text ((GtkEntry*) self);
#line 66 "../src/Widgets/UrlEntry.vala"
	_tmp29_ = _tmp28_;
#line 66 "../src/Widgets/UrlEntry.vala"
	webkit_web_view_load_uri (_tmp27_, _tmp29_);
#line 67 "../src/Widgets/UrlEntry.vala"
	_tmp30_ = self->priv->_web_view;
#line 67 "../src/Widgets/UrlEntry.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp30_);
#line 50 "../src/Widgets/UrlEntry.vala"
	_g_free0 (search_engine);
#line 1738 "UrlEntry.c"
}

static void
__url_entry___lambda4__gtk_entry_activate (GtkEntry* _sender,
                                           gpointer self)
{
#line 50 "../src/Widgets/UrlEntry.vala"
	_url_entry___lambda4_ ((UrlEntry*) self);
#line 1747 "UrlEntry.c"
}

static gboolean
_url_entry___lambda5_ (UrlEntry* self,
                       GdkEventFocus* event)
{
	gboolean result = FALSE;
#line 70 "../src/Widgets/UrlEntry.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 71 "../src/Widgets/UrlEntry.vala"
	url_entry_set_secondary_icon (self);
#line 73 "../src/Widgets/UrlEntry.vala"
	result = FALSE;
#line 73 "../src/Widgets/UrlEntry.vala"
	return result;
#line 1763 "UrlEntry.c"
}

static gboolean
__url_entry___lambda5__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self)
{
	gboolean result;
	result = _url_entry___lambda5_ ((UrlEntry*) self, event);
#line 70 "../src/Widgets/UrlEntry.vala"
	return result;
#line 1775 "UrlEntry.c"
}

static gboolean
_url_entry___lambda6_ (UrlEntry* self,
                       GdkEventFocus* event)
{
	gboolean result = FALSE;
	gchar* uri = NULL;
	WebKitWebView* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
#line 76 "../src/Widgets/UrlEntry.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 77 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = self->priv->_web_view;
#line 77 "../src/Widgets/UrlEntry.vala"
	_tmp1_ = webkit_web_view_get_uri (_tmp0_);
#line 77 "../src/Widgets/UrlEntry.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 77 "../src/Widgets/UrlEntry.vala"
	uri = _tmp2_;
#line 79 "../src/Widgets/UrlEntry.vala"
	_tmp4_ = uri;
#line 79 "../src/Widgets/UrlEntry.vala"
	if (_tmp4_ == NULL) {
#line 79 "../src/Widgets/UrlEntry.vala"
		_tmp3_ = TRUE;
#line 1805 "UrlEntry.c"
	} else {
		const gchar* _tmp5_;
#line 79 "../src/Widgets/UrlEntry.vala"
		_tmp5_ = uri;
#line 79 "../src/Widgets/UrlEntry.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, "about:blank") == 0;
#line 1812 "UrlEntry.c"
	}
#line 79 "../src/Widgets/UrlEntry.vala"
	if (_tmp3_) {
#line 80 "../src/Widgets/UrlEntry.vala"
		gtk_entry_set_text ((GtkEntry*) self, "");
#line 1818 "UrlEntry.c"
	} else {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 81 "../src/Widgets/UrlEntry.vala"
		_tmp6_ = gtk_entry_get_text ((GtkEntry*) self);
#line 81 "../src/Widgets/UrlEntry.vala"
		_tmp7_ = _tmp6_;
#line 81 "../src/Widgets/UrlEntry.vala"
		if (g_strcmp0 (_tmp7_, "") == 0) {
#line 1828 "UrlEntry.c"
			const gchar* _tmp8_;
#line 82 "../src/Widgets/UrlEntry.vala"
			_tmp8_ = uri;
#line 82 "../src/Widgets/UrlEntry.vala"
			gtk_entry_set_text ((GtkEntry*) self, _tmp8_);
#line 1834 "UrlEntry.c"
		}
	}
#line 85 "../src/Widgets/UrlEntry.vala"
	url_entry_set_secondary_icon (self);
#line 87 "../src/Widgets/UrlEntry.vala"
	result = FALSE;
#line 87 "../src/Widgets/UrlEntry.vala"
	_g_free0 (uri);
#line 87 "../src/Widgets/UrlEntry.vala"
	return result;
#line 1845 "UrlEntry.c"
}

static gboolean
__url_entry___lambda6__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                   GdkEventFocus* event,
                                                   gpointer self)
{
	gboolean result;
	result = _url_entry___lambda6_ ((UrlEntry*) self, event);
#line 76 "../src/Widgets/UrlEntry.vala"
	return result;
#line 1857 "UrlEntry.c"
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 108 "../src/Widgets/UrlEntry.vala"
	if ((*length) == (*size)) {
#line 108 "../src/Widgets/UrlEntry.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 108 "../src/Widgets/UrlEntry.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1872 "UrlEntry.c"
	}
#line 108 "../src/Widgets/UrlEntry.vala"
	(*array)[(*length)++] = value;
#line 108 "../src/Widgets/UrlEntry.vala"
	(*array)[*length] = NULL;
#line 1878 "UrlEntry.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 112 "../src/Widgets/UrlEntry.vala"
	result = g_new0 (gchar*, length + 1);
#line 112 "../src/Widgets/UrlEntry.vala"
	for (i = 0; i < length; i++) {
#line 1891 "UrlEntry.c"
		gchar* _tmp0_;
#line 112 "../src/Widgets/UrlEntry.vala"
		_tmp0_ = g_strdup (self[i]);
#line 112 "../src/Widgets/UrlEntry.vala"
		result[i] = _tmp0_;
#line 1897 "UrlEntry.c"
	}
#line 112 "../src/Widgets/UrlEntry.vala"
	return result;
#line 1901 "UrlEntry.c"
}

static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 116 "../src/Widgets/UrlEntry.vala"
	if ((*length) == (*size)) {
#line 116 "../src/Widgets/UrlEntry.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 116 "../src/Widgets/UrlEntry.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1916 "UrlEntry.c"
	}
#line 116 "../src/Widgets/UrlEntry.vala"
	(*array)[(*length)++] = value;
#line 116 "../src/Widgets/UrlEntry.vala"
	(*array)[*length] = NULL;
#line 1922 "UrlEntry.c"
}

static void
_url_entry___lambda7_ (UrlEntry* self,
                       GtkEntryIconPosition icon_pos,
                       GdkEventButton* event)
{
#line 90 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (event != NULL);
#line 91 "../src/Widgets/UrlEntry.vala"
	if (icon_pos == GTK_ENTRY_ICON_PRIMARY) {
#line 92 "../src/Widgets/UrlEntry.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1936 "UrlEntry.c"
	} else {
#line 93 "../src/Widgets/UrlEntry.vala"
		if (icon_pos == GTK_ENTRY_ICON_SECONDARY) {
#line 1940 "UrlEntry.c"
			gboolean _tmp0_;
			gboolean _tmp1_;
#line 94 "../src/Widgets/UrlEntry.vala"
			g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 94 "../src/Widgets/UrlEntry.vala"
			_tmp1_ = _tmp0_;
#line 94 "../src/Widgets/UrlEntry.vala"
			if (_tmp1_) {
#line 95 "../src/Widgets/UrlEntry.vala"
				g_signal_emit_by_name ((GtkEntry*) self, "activate");
#line 1951 "UrlEntry.c"
			} else {
				gchar** current_favorites = NULL;
				GSettings* _tmp2_;
				gchar** _tmp3_;
				gchar** _tmp4_;
				gint current_favorites_length1;
				gint _current_favorites_size_;
				SoupURI* uri = NULL;
				WebKitWebView* _tmp5_;
				const gchar* _tmp6_;
				SoupURI* _tmp7_;
				SoupURI* _tmp8_;
#line 97 "../src/Widgets/UrlEntry.vala"
				_tmp2_ = ephemeral_settings;
#line 97 "../src/Widgets/UrlEntry.vala"
				_tmp4_ = _tmp3_ = g_settings_get_strv (_tmp2_, "favorite-websites");
#line 97 "../src/Widgets/UrlEntry.vala"
				current_favorites = _tmp4_;
#line 97 "../src/Widgets/UrlEntry.vala"
				current_favorites_length1 = _vala_array_length (_tmp3_);
#line 97 "../src/Widgets/UrlEntry.vala"
				_current_favorites_size_ = current_favorites_length1;
#line 98 "../src/Widgets/UrlEntry.vala"
				_tmp5_ = self->priv->_web_view;
#line 98 "../src/Widgets/UrlEntry.vala"
				_tmp6_ = webkit_web_view_get_uri (_tmp5_);
#line 98 "../src/Widgets/UrlEntry.vala"
				_tmp7_ = soup_uri_new (_tmp6_);
#line 98 "../src/Widgets/UrlEntry.vala"
				uri = _tmp7_;
#line 100 "../src/Widgets/UrlEntry.vala"
				_tmp8_ = uri;
#line 100 "../src/Widgets/UrlEntry.vala"
				if (_tmp8_ != NULL) {
#line 1986 "UrlEntry.c"
					gchar* favorite = NULL;
					SoupURI* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
					gchar** _tmp13_;
					gint _tmp13__length1;
					GSettings* _tmp31_;
					gchar** _tmp32_;
					gint _tmp32__length1;
#line 101 "../src/Widgets/UrlEntry.vala"
					_tmp9_ = uri;
#line 101 "../src/Widgets/UrlEntry.vala"
					_tmp10_ = soup_uri_get_host (_tmp9_);
#line 101 "../src/Widgets/UrlEntry.vala"
					_tmp11_ = g_strdup (_tmp10_);
#line 101 "../src/Widgets/UrlEntry.vala"
					favorite = _tmp11_;
#line 103 "../src/Widgets/UrlEntry.vala"
					_tmp12_ = favorite;
#line 103 "../src/Widgets/UrlEntry.vala"
					_tmp13_ = current_favorites;
#line 103 "../src/Widgets/UrlEntry.vala"
					_tmp13__length1 = current_favorites_length1;
#line 103 "../src/Widgets/UrlEntry.vala"
					if (_vala_string_array_contains (_tmp13_, _tmp13__length1, _tmp12_)) {
#line 2013 "UrlEntry.c"
						const gchar* _tmp14_;
						gchar** pruned_favorites = NULL;
						gchar** _tmp15_;
						gint pruned_favorites_length1;
						gint _pruned_favorites_size_;
						gchar** _tmp16_;
						gint _tmp16__length1;
						gchar** _tmp23_;
						gint _tmp23__length1;
						gchar** _tmp24_;
						gint _tmp24__length1;
						gchar** _tmp25_;
						gint _tmp25__length1;
#line 104 "../src/Widgets/UrlEntry.vala"
						_tmp14_ = favorite;
#line 104 "../src/Widgets/UrlEntry.vala"
						g_debug ("UrlEntry.vala:104: %s is already a favorite, so removing…", _tmp14_);
#line 105 "../src/Widgets/UrlEntry.vala"
						_tmp15_ = g_new0 (gchar*, 0 + 1);
#line 105 "../src/Widgets/UrlEntry.vala"
						pruned_favorites = _tmp15_;
#line 105 "../src/Widgets/UrlEntry.vala"
						pruned_favorites_length1 = 0;
#line 105 "../src/Widgets/UrlEntry.vala"
						_pruned_favorites_size_ = pruned_favorites_length1;
#line 106 "../src/Widgets/UrlEntry.vala"
						_tmp16_ = current_favorites;
#line 106 "../src/Widgets/UrlEntry.vala"
						_tmp16__length1 = current_favorites_length1;
#line 2043 "UrlEntry.c"
						{
							gchar** existing_favorite_collection = NULL;
							gint existing_favorite_collection_length1 = 0;
							gint _existing_favorite_collection_size_ = 0;
							gint existing_favorite_it = 0;
#line 106 "../src/Widgets/UrlEntry.vala"
							existing_favorite_collection = _tmp16_;
#line 106 "../src/Widgets/UrlEntry.vala"
							existing_favorite_collection_length1 = _tmp16__length1;
#line 106 "../src/Widgets/UrlEntry.vala"
							for (existing_favorite_it = 0; existing_favorite_it < _tmp16__length1; existing_favorite_it = existing_favorite_it + 1) {
#line 2055 "UrlEntry.c"
								gchar* _tmp17_;
								gchar* existing_favorite = NULL;
#line 106 "../src/Widgets/UrlEntry.vala"
								_tmp17_ = g_strdup (existing_favorite_collection[existing_favorite_it]);
#line 106 "../src/Widgets/UrlEntry.vala"
								existing_favorite = _tmp17_;
#line 2062 "UrlEntry.c"
								{
									const gchar* _tmp18_;
									const gchar* _tmp19_;
#line 107 "../src/Widgets/UrlEntry.vala"
									_tmp18_ = existing_favorite;
#line 107 "../src/Widgets/UrlEntry.vala"
									_tmp19_ = favorite;
#line 107 "../src/Widgets/UrlEntry.vala"
									if (g_strcmp0 (_tmp18_, _tmp19_) != 0) {
#line 2072 "UrlEntry.c"
										gchar** _tmp20_;
										gint _tmp20__length1;
										const gchar* _tmp21_;
										gchar* _tmp22_;
#line 108 "../src/Widgets/UrlEntry.vala"
										_tmp20_ = pruned_favorites;
#line 108 "../src/Widgets/UrlEntry.vala"
										_tmp20__length1 = pruned_favorites_length1;
#line 108 "../src/Widgets/UrlEntry.vala"
										_tmp21_ = existing_favorite;
#line 108 "../src/Widgets/UrlEntry.vala"
										_tmp22_ = g_strdup (_tmp21_);
#line 108 "../src/Widgets/UrlEntry.vala"
										_vala_array_add1 (&pruned_favorites, &pruned_favorites_length1, &_pruned_favorites_size_, _tmp22_);
#line 2087 "UrlEntry.c"
									}
#line 106 "../src/Widgets/UrlEntry.vala"
									_g_free0 (existing_favorite);
#line 2091 "UrlEntry.c"
								}
							}
						}
#line 112 "../src/Widgets/UrlEntry.vala"
						_tmp23_ = pruned_favorites;
#line 112 "../src/Widgets/UrlEntry.vala"
						_tmp23__length1 = pruned_favorites_length1;
#line 112 "../src/Widgets/UrlEntry.vala"
						_tmp24_ = (_tmp23_ != NULL) ? _vala_array_dup1 (_tmp23_, _tmp23__length1) : ((gpointer) _tmp23_);
#line 112 "../src/Widgets/UrlEntry.vala"
						_tmp24__length1 = _tmp23__length1;
#line 112 "../src/Widgets/UrlEntry.vala"
						current_favorites = (_vala_array_free (current_favorites, current_favorites_length1, (GDestroyNotify) g_free), NULL);
#line 112 "../src/Widgets/UrlEntry.vala"
						current_favorites = _tmp24_;
#line 112 "../src/Widgets/UrlEntry.vala"
						current_favorites_length1 = _tmp24__length1;
#line 112 "../src/Widgets/UrlEntry.vala"
						_current_favorites_size_ = current_favorites_length1;
#line 113 "../src/Widgets/UrlEntry.vala"
						_tmp25_ = current_favorites;
#line 113 "../src/Widgets/UrlEntry.vala"
						_tmp25__length1 = current_favorites_length1;
#line 113 "../src/Widgets/UrlEntry.vala"
						url_entry_reset_suggestions (self, _tmp25_, (gint) _tmp25__length1);
#line 103 "../src/Widgets/UrlEntry.vala"
						pruned_favorites = (_vala_array_free (pruned_favorites, pruned_favorites_length1, (GDestroyNotify) g_free), NULL);
#line 2119 "UrlEntry.c"
					} else {
						const gchar* _tmp26_;
						gchar** _tmp27_;
						gint _tmp27__length1;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar** _tmp30_;
						gint _tmp30__length1;
#line 115 "../src/Widgets/UrlEntry.vala"
						_tmp26_ = favorite;
#line 115 "../src/Widgets/UrlEntry.vala"
						g_debug ("UrlEntry.vala:115: %s is not a favorite, so adding…", _tmp26_);
#line 116 "../src/Widgets/UrlEntry.vala"
						_tmp27_ = current_favorites;
#line 116 "../src/Widgets/UrlEntry.vala"
						_tmp27__length1 = current_favorites_length1;
#line 116 "../src/Widgets/UrlEntry.vala"
						_tmp28_ = favorite;
#line 116 "../src/Widgets/UrlEntry.vala"
						_tmp29_ = g_strdup (_tmp28_);
#line 116 "../src/Widgets/UrlEntry.vala"
						_vala_array_add2 (&current_favorites, &current_favorites_length1, &_current_favorites_size_, _tmp29_);
#line 117 "../src/Widgets/UrlEntry.vala"
						_tmp30_ = current_favorites;
#line 117 "../src/Widgets/UrlEntry.vala"
						_tmp30__length1 = current_favorites_length1;
#line 117 "../src/Widgets/UrlEntry.vala"
						url_entry_reset_suggestions (self, _tmp30_, (gint) _tmp30__length1);
#line 2148 "UrlEntry.c"
					}
#line 120 "../src/Widgets/UrlEntry.vala"
					_tmp31_ = ephemeral_settings;
#line 120 "../src/Widgets/UrlEntry.vala"
					_tmp32_ = current_favorites;
#line 120 "../src/Widgets/UrlEntry.vala"
					_tmp32__length1 = current_favorites_length1;
#line 120 "../src/Widgets/UrlEntry.vala"
					g_settings_set_strv (_tmp31_, "favorite-websites", _tmp32_);
#line 121 "../src/Widgets/UrlEntry.vala"
					url_entry_set_secondary_icon (self);
#line 100 "../src/Widgets/UrlEntry.vala"
					_g_free0 (favorite);
#line 2162 "UrlEntry.c"
				}
#line 94 "../src/Widgets/UrlEntry.vala"
				__vala_SoupURI_free0 (uri);
#line 94 "../src/Widgets/UrlEntry.vala"
				current_favorites = (_vala_array_free (current_favorites, current_favorites_length1, (GDestroyNotify) g_free), NULL);
#line 2168 "UrlEntry.c"
			}
		}
	}
}

static void
__url_entry___lambda7__gtk_entry_icon_release (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEventButton* event,
                                               gpointer self)
{
#line 90 "../src/Widgets/UrlEntry.vala"
	_url_entry___lambda7_ ((UrlEntry*) self, icon_pos, event);
#line 2182 "UrlEntry.c"
}

static void
_url_entry___lambda8_ (UrlEntry* self,
                       WebKitWebView* source,
                       WebKitLoadEvent e)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 128 "../src/Widgets/UrlEntry.vala"
	g_return_if_fail (source != NULL);
#line 129 "../src/Widgets/UrlEntry.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
#line 129 "../src/Widgets/UrlEntry.vala"
	_tmp1_ = _tmp0_;
#line 129 "../src/Widgets/UrlEntry.vala"
	if (!_tmp1_) {
#line 2200 "UrlEntry.c"
		const gchar* _tmp2_;
#line 130 "../src/Widgets/UrlEntry.vala"
		_tmp2_ = webkit_web_view_get_uri (source);
#line 130 "../src/Widgets/UrlEntry.vala"
		gtk_entry_set_text ((GtkEntry*) self, _tmp2_);
#line 131 "../src/Widgets/UrlEntry.vala"
		url_entry_set_secondary_icon (self);
#line 2208 "UrlEntry.c"
	}
}

static void
__url_entry___lambda8__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                     WebKitLoadEvent load_event,
                                                     gpointer self)
{
#line 128 "../src/Widgets/UrlEntry.vala"
	_url_entry___lambda8_ ((UrlEntry*) self, _sender, load_event);
#line 2219 "UrlEntry.c"
}

static GObject *
url_entry_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	UrlEntry * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** initial_favorites = NULL;
	GSettings* _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint initial_favorites_length1;
	gint _initial_favorites_size_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	WebKitWebView* _tmp23_;
#line 36 "../src/Widgets/UrlEntry.vala"
	parent_class = G_OBJECT_CLASS (url_entry_parent_class);
#line 36 "../src/Widgets/UrlEntry.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/Widgets/UrlEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_URL_ENTRY, UrlEntry);
#line 37 "../src/Widgets/UrlEntry.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("Enter a URL or search term"));
#line 38 "../src/Widgets/UrlEntry.vala"
	_tmp0_ = gtk_widget_get_tooltip_text ((GtkWidget*) self);
#line 38 "../src/Widgets/UrlEntry.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/Widgets/UrlEntry.vala"
	_tmp2_ = _tmp1_;
#line 38 "../src/Widgets/UrlEntry.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) self, _tmp2_);
#line 38 "../src/Widgets/UrlEntry.vala"
	_g_free0 (_tmp2_);
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp3_ = g_strdup ("<Ctrl>l");
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp4_[0] = _tmp3_;
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp5_ = _tmp4_;
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp5__length1 = 1;
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp6_ = gtk_widget_get_tooltip_text ((GtkWidget*) self);
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp7_ = _tmp6_;
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp8_ = _tmp7_;
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp9_ = granite_markup_accel_tooltip (_tmp5_, (gint) 1, _tmp8_);
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp10_ = _tmp9_;
#line 40 "../src/Widgets/UrlEntry.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) self, _tmp10_);
#line 40 "../src/Widgets/UrlEntry.vala"
	_g_free0 (_tmp10_);
#line 40 "../src/Widgets/UrlEntry.vala"
	_g_free0 (_tmp8_);
#line 40 "../src/Widgets/UrlEntry.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/Widgets/UrlEntry.vala"
	g_object_set ((GtkEntry*) self, "primary-icon-name", "system-search-symbolic", NULL);
#line 43 "../src/Widgets/UrlEntry.vala"
	g_object_set ((GtkEntry*) self, "primary-icon-tooltip-text", _ ("Enter a URL or search term"), NULL);
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp11_ = g_strdup ("<Ctrl>l");
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp12_[0] = _tmp11_;
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp13_ = _tmp12_;
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp13__length1 = 1;
#line 44 "../src/Widgets/UrlEntry.vala"
	g_object_get ((GtkEntry*) self, "primary-icon-tooltip-text", &_tmp14_, NULL);
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp15_ = _tmp14_;
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp16_ = _tmp15_;
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp17_ = granite_markup_accel_tooltip (_tmp13_, (gint) 1, _tmp16_);
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp18_ = _tmp17_;
#line 44 "../src/Widgets/UrlEntry.vala"
	g_object_set ((GtkEntry*) self, "primary-icon-tooltip-markup", _tmp18_, NULL);
#line 44 "../src/Widgets/UrlEntry.vala"
	_g_free0 (_tmp18_);
#line 44 "../src/Widgets/UrlEntry.vala"
	_g_free0 (_tmp16_);
#line 44 "../src/Widgets/UrlEntry.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 46 "../src/Widgets/UrlEntry.vala"
	_tmp19_ = ephemeral_settings;
#line 46 "../src/Widgets/UrlEntry.vala"
	_tmp21_ = _tmp20_ = g_settings_get_strv (_tmp19_, "favorite-websites");
#line 46 "../src/Widgets/UrlEntry.vala"
	initial_favorites = _tmp21_;
#line 46 "../src/Widgets/UrlEntry.vala"
	initial_favorites_length1 = _vala_array_length (_tmp20_);
#line 46 "../src/Widgets/UrlEntry.vala"
	_initial_favorites_size_ = initial_favorites_length1;
#line 47 "../src/Widgets/UrlEntry.vala"
	_tmp22_ = initial_favorites;
#line 47 "../src/Widgets/UrlEntry.vala"
	_tmp22__length1 = initial_favorites_length1;
#line 47 "../src/Widgets/UrlEntry.vala"
	url_entry_reset_suggestions (self, _tmp22_, (gint) _tmp22__length1);
#line 48 "../src/Widgets/UrlEntry.vala"
	url_entry_set_secondary_icon (self);
#line 50 "../src/Widgets/UrlEntry.vala"
	g_signal_connect_object ((GtkEntry*) self, "activate", (GCallback) __url_entry___lambda4__gtk_entry_activate, self, 0);
#line 70 "../src/Widgets/UrlEntry.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-in-event", (GCallback) __url_entry___lambda5__gtk_widget_focus_in_event, self, 0);
#line 76 "../src/Widgets/UrlEntry.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) __url_entry___lambda6__gtk_widget_focus_out_event, self, 0);
#line 90 "../src/Widgets/UrlEntry.vala"
	g_signal_connect_object ((GtkEntry*) self, "icon-release", (GCallback) __url_entry___lambda7__gtk_entry_icon_release, self, 0);
#line 128 "../src/Widgets/UrlEntry.vala"
	_tmp23_ = self->priv->_web_view;
#line 128 "../src/Widgets/UrlEntry.vala"
	g_signal_connect_object (_tmp23_, "load-changed", (GCallback) __url_entry___lambda8__webkit_web_view_load_changed, self, 0);
#line 36 "../src/Widgets/UrlEntry.vala"
	initial_favorites = (_vala_array_free (initial_favorites, initial_favorites_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../src/Widgets/UrlEntry.vala"
	return obj;
#line 2372 "UrlEntry.c"
}

static void
url_entry_class_init (UrlEntryClass * klass,
                      gpointer klass_data)
{
#line 22 "../src/Widgets/UrlEntry.vala"
	url_entry_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/UrlEntry.vala"
	g_type_class_adjust_private_offset (klass, &UrlEntry_private_offset);
#line 22 "../src/Widgets/UrlEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_url_entry_get_property;
#line 22 "../src/Widgets/UrlEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_url_entry_set_property;
#line 22 "../src/Widgets/UrlEntry.vala"
	G_OBJECT_CLASS (klass)->constructor = url_entry_constructor;
#line 22 "../src/Widgets/UrlEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = url_entry_finalize;
#line 22 "../src/Widgets/UrlEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), URL_ENTRY_WEB_VIEW_PROPERTY, url_entry_properties[URL_ENTRY_WEB_VIEW_PROPERTY] = g_param_spec_object ("web-view", "web-view", "web-view", webkit_web_view_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 2393 "UrlEntry.c"
}

static void
url_entry_instance_init (UrlEntry * self,
                         gpointer klass)
{
#line 22 "../src/Widgets/UrlEntry.vala"
	self->priv = url_entry_get_instance_private (self);
#line 2402 "UrlEntry.c"
}

static void
url_entry_finalize (GObject * obj)
{
	UrlEntry * self;
#line 22 "../src/Widgets/UrlEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_URL_ENTRY, UrlEntry);
#line 23 "../src/Widgets/UrlEntry.vala"
	_g_object_unref0 (self->priv->_list_store);
#line 26 "../src/Widgets/UrlEntry.vala"
	_g_object_unref0 (self->priv->_web_view);
#line 22 "../src/Widgets/UrlEntry.vala"
	G_OBJECT_CLASS (url_entry_parent_class)->finalize (obj);
#line 2417 "UrlEntry.c"
}

GType
url_entry_get_type (void)
{
	static volatile gsize url_entry_type_id__volatile = 0;
	if (g_once_init_enter (&url_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UrlEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) url_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UrlEntry), 0, (GInstanceInitFunc) url_entry_instance_init, NULL };
		GType url_entry_type_id;
		url_entry_type_id = g_type_register_static (gtk_entry_get_type (), "UrlEntry", &g_define_type_info, 0);
		UrlEntry_private_offset = g_type_add_instance_private (url_entry_type_id, sizeof (UrlEntryPrivate));
		g_once_init_leave (&url_entry_type_id__volatile, url_entry_type_id);
	}
	return url_entry_type_id__volatile;
}

static void
_vala_url_entry_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	UrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_URL_ENTRY, UrlEntry);
#line 22 "../src/Widgets/UrlEntry.vala"
	switch (property_id) {
#line 22 "../src/Widgets/UrlEntry.vala"
		case URL_ENTRY_WEB_VIEW_PROPERTY:
#line 22 "../src/Widgets/UrlEntry.vala"
		g_value_set_object (value, url_entry_get_web_view (self));
#line 22 "../src/Widgets/UrlEntry.vala"
		break;
#line 2450 "UrlEntry.c"
		default:
#line 22 "../src/Widgets/UrlEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/UrlEntry.vala"
		break;
#line 2456 "UrlEntry.c"
	}
}

static void
_vala_url_entry_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	UrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_URL_ENTRY, UrlEntry);
#line 22 "../src/Widgets/UrlEntry.vala"
	switch (property_id) {
#line 22 "../src/Widgets/UrlEntry.vala"
		case URL_ENTRY_WEB_VIEW_PROPERTY:
#line 22 "../src/Widgets/UrlEntry.vala"
		url_entry_set_web_view (self, g_value_get_object (value));
#line 22 "../src/Widgets/UrlEntry.vala"
		break;
#line 2476 "UrlEntry.c"
		default:
#line 22 "../src/Widgets/UrlEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/UrlEntry.vala"
		break;
#line 2482 "UrlEntry.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

